// Updates: 2002.07.02


/*
 * Programme tourant sur le RCX permettant de calibrer ce dernier.
 */
 
 
import josx.robotics.*;
import josx.rcxcomm.*; 
import josx.platform.rcx.*;
import josx.util.*;
import java.io.*;


public class CalibRCX {
  short powerA;
  short powerC;
  float timeOneMeter;
  float timeRotate;
  short delay;
  DataInputStream in;
  TimingNavigator nav;
  

  public CalibRCX() {
    RCXPort port = null;
    try {
      port = new RCXPort(); 
    }
    catch (IOException e) {}
    
    in = new DataInputStream(port.getInputStream());          
    while (true) {
      calibrate();
      try {
        short msg = in.readShort();
        if (msg == 1) {
          Motor.A.forward();
          Motor.C.forward();
        }
        if (msg == 2) {
          Motor.A.backward();
          Motor.C.backward();
        }     
        if (msg == 3) {
          Motor.A.backward();
          Motor.C.forward();
        }     
        if (msg == 4) {
          Motor.A.forward();
          Motor.C.backward();
        }     
        if (msg == 5) {
          nav.rotate(360);
        }
        if (msg == 6) {
          nav.rotate(-360);
        }
        if (msg == 7) {
          for (int i = 0; i < 36; i++) {
            nav.rotate(10);
            wait(100);
          }
        }
        if (msg == 8) {
          for (int i = 0; i < 36; i++) {
            nav.rotate(-10);
            wait(100);
          }          
        }
        if (msg == 9) {
          nav.travel(100);
        }
        if (msg == 10) {
          nav.travel(-100);      
        }   
      }
      catch (IOException e) {}
    }
  }    

    
  public static void main(String[] args) {
    Serial.setRangeLong();
    new CalibRCX();
  }
  
  
  private void calibrate() {
    try {
      powerA = in.readShort();
      powerC = in.readShort();
      timeOneMeter = (float)in.readInt() / 100000.0f;
      timeRotate = (float)in.readInt() / 100000.0f;
      delay = in.readShort();
    }
    catch (IOException e) {}
    Motor.A.setPower(powerA);
    Motor.C.setPower(powerC);    
    nav = new TimingNavigator(Motor.C, Motor.A, timeOneMeter, timeRotate);    
    nav.setMomentumDelay(delay);     
  }
  
  
  private void wait(int t) {
    try {
      Thread.sleep(t);
    } catch (InterruptedException e) {}       
  }
}    