/* EHRLER FREDERIC - MICHEL DERIAZ
 * ------------------------------------------------------------------
 * Classe qui represente l'image traitee. On fait a partir de cette 
 * classe tout les appel au methode d'analyse d'image et de recherche
 * d'objet.
 * On peut egalement demander d'afficher different objet sur l'image.
 */

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.awt.image.*;
import java.awt.image.renderable.*;
import javax.media.jai.*;
import java.awt.color.*;

class AnalysedImageJAI extends JPanel{
	BufferedImage mainBuffImg;
	
	AnalysedImageJAI(Image img) {		
		setPreferredSize(new Dimension(3*320,3*240));
		
		MediaTracker mt = new MediaTracker(this);
		mt.addImage(img,0);
     	try {
       		mt.waitForID(0);
     	} 
     	catch (InterruptedException e) {}
		
		ParameterBlock pb = new ParameterBlock();
		pb.add(img);
		PlanarImage im = (PlanarImage)JAI.create("awtImage",pb);
		
		mainBuffImg = im.getAsBufferedImage();
	}
	
	AnalysedImageJAI(BufferedImage img) {		
		setPreferredSize(new Dimension(3*320,3*240));
		mainBuffImg = img;
	}
	
	public BufferedImage getTransformImage(){
		return mainBuffImg;
	}
	
	public void setTransformImage(BufferedImage imgSource){
		this.mainBuffImg = imgSource;
	}
	
	public void drawQuadrillage(){
		Graphics g = mainBuffImg.getGraphics();
		g.setColor(Color.black);
		for (int i=0; i<360; i+=10){
			g.drawLine(i,0,i,240);
		}
		for (int j=0; j<240; j+=10){
			g.drawLine(0,j,360,j);
		}		
	}
	
	public void drawWall(int[] wall, boolean gauche){
		Graphics g = mainBuffImg.getGraphics();
		//g.drawLine(wall[0],0,wall[0],240);
		//g.drawLine(0,wall[1],320,wall[1]);
		g.fillRect(wall[0],0,5,240);
		if (gauche){
			g.fillRect(0,wall[1],wall[0],5);
		} else {
			g.fillRect(wall[0],wall[1],320-wall[0],5);
		}
	}
	
	
	public void drawDoor(int[] wall, int[][] doors){
		System.out.println("valeur de porte := "+doors[0][0]+";"+doors[1][0]+";"+doors[1][0]+";"+doors[1][1]);
		System.out.println("dessin des portes ********************************");
		System.out.println("dessin d'un rectangle "+wall[0]+";"+doors[1][0]+"de largeur 5 et hauteur"+(doors[1][1]-doors[1][0]));
		
		Graphics g = mainBuffImg.getGraphics();
		//g.drawLine(wall[0],0,wall[0],240);
		//g.drawLine(0,wall[1],320,wall[1]);
		g.setColor(Color.orange);
		g.fillRect(wall[0],doors[1][0],5,doors[1][1]-doors[1][0]);
		g.fillRect(doors[0][0],wall[1],doors[0][1]-doors[0][0],5);
	}
	
	
	public void drawCylinder(int[] posRedCylinder, int redDiameter, int[] posGreenCylinder, int greenDiameter ,int[] posBlueCylinder, int blueDiameter){
		Graphics g = mainBuffImg.getGraphics();
		g.setColor(Color.red);
		g.fillOval(posRedCylinder[0], posRedCylinder[1],redDiameter,redDiameter);
		g.setColor(Color.green);
		g.fillOval(posGreenCylinder[0], posGreenCylinder[1],greenDiameter,greenDiameter);
		g.setColor(Color.blue);
		g.fillOval(posBlueCylinder[0], posBlueCylinder[1],blueDiameter,blueDiameter);
	}
	
	public void drawRobot(int[] posRobot, int robotSizeX, int robotSizeY){
		Graphics g = mainBuffImg.getGraphics();
		g.setColor(Color.yellow);
		g.fillRect(posRobot[0], posRobot[1],10,10);
	}
	
	public void drawRobotOrientation(int[] robotGCenter, int[] robotTop){
		Graphics g = mainBuffImg.getGraphics();
		g.setColor(Color.yellow);
		g.drawLine(robotGCenter[0], robotGCenter[1],robotTop[0],robotTop[1]);
	}
	
	public void drawTopRobot(int[] avantRobot){
		Graphics g = mainBuffImg.getGraphics();
		g.setColor(Color.pink);
		g.fillOval(avantRobot[0], avantRobot[1],10,10);
	}
	
	public void drawRobot(int[][] coinRobot){
		System.out.println("dessin du robot polygone -----------------");
		System.out.println("the four points are "+coinRobot[0][0]+";"+coinRobot[0][1]+" "+coinRobot[1][0]+";"+coinRobot[1][1]+" "+coinRobot[2][0]+";"+coinRobot[2][1]+" "+coinRobot[3][0]+";"+coinRobot[3][1]);
		// VOIR QUELS SONT LES POINTS
		
		int[] xpoints = new int[4];
		int[] ypoints = new int[4];
		xpoints[0] = coinRobot[0][0];
		xpoints[1] = coinRobot[2][0];
		xpoints[2] = coinRobot[1][0];
		xpoints[3] = coinRobot[3][0];
		
		ypoints[0] = coinRobot[0][1];
		ypoints[1] = coinRobot[2][1];
		ypoints[2] = coinRobot[1][1];
		ypoints[3] = coinRobot[3][1];
		Graphics g = mainBuffImg.getGraphics();
		g.setColor(Color.magenta);
		Polygon forme = new Polygon(xpoints,ypoints,4);
		g.fillPolygon(forme);
	}
	

	public void getBand(int band){
		mainBuffImg = ImageTools.getBand(mainBuffImg,band);
	}
	
	
	public void rescale(){
		mainBuffImg = ImageTools.rescale(mainBuffImg);
	}
		
	
	public void binarize(double seuil){
		mainBuffImg = ImageTools.binarize(mainBuffImg,seuil);
	}
	
	public void substract(BufferedImage img1, BufferedImage img2){
		mainBuffImg = ImageTools.substractImage(img1, img2);
	}
	
	public void filter(int nbPasse, int TailleFiltre){
		for (int i=0; i<nbPasse; i++){
			mainBuffImg = ImageTools.filter(mainBuffImg, TailleFiltre);
		}
	}
	
	public void applyBorder(int borderSize, int borderValue){
		mainBuffImg = ImageTools.applyBorder(mainBuffImg, borderSize, borderValue);
	}
	
	public void correctGamma(double gamma){
		mainBuffImg = ImageTools.correctGamma(mainBuffImg, gamma);
	}

	public void noireBlanc(){
		mainBuffImg = ImageTools.noireBlanc(mainBuffImg);
	}
	
	public void selectColorOperator(int colorOpDiff, int colorOpMinSeuil){
		//Raster pixels = mainBuffImg.getData();
		//mainBuffImg  = ImageTools.selectColorOperator(pixels, colorOpDiff, colorOpMinSeuil);
		mainBuffImg  = ImageTools.selectColorOperator(mainBuffImg, colorOpDiff, colorOpMinSeuil);
	}
	
	public void selectAllColor(int blackValue){
		mainBuffImg = ImageTools.selectAllColor(mainBuffImg, blackValue);
	}
		
	public void changeImage(Image img){
	
	}
	
	public void reset(){
	}

	public void getPixel(int x, int y){
		//int[] data= null;
		//data = pixels.getPixel(x,y,data);
		//System.out.println("value pixel "+x+";"+y+" := "+data[0]+"//"+data[1]+"//"+data[2]);
	}
	
	public int[] foundRedCylinder(int borneX, int redCylSurf, int bord, boolean gauche){
		int[] posRedCylinder = RobotTools.foundRedCylinder(mainBuffImg,borneX,redCylSurf,bord,gauche);
		return posRedCylinder;
	}
	
	public int[] foundGreenCylinder(int borneX, int greenCylSurf, int bord, boolean gauche){
		int[] posGreenCylinder = RobotTools.foundGreenCylinder(mainBuffImg,borneX,greenCylSurf,bord,gauche);
		return posGreenCylinder;
	}
	
	public int[] foundGreenCylinderFromGreen(int borneX, int greenCylSurf, int bord, boolean gauche,int[] posBlueCylinder){
		int[] posGreenCylinder = RobotTools.foundGreenCylinderFromGreen(mainBuffImg,borneX,greenCylSurf,bord,gauche,posBlueCylinder);
		return posGreenCylinder;
	}
	
	public int[] foundBlueCylinder(int borneX, int blueCylSurf, int bord, boolean gauche){
		int[] posBlueCylinder = RobotTools.foundBlueCylinder(mainBuffImg,borneX,blueCylSurf,bord,gauche);
		return posBlueCylinder;
	}
	
	public int[] foundBlueCylinderFromBlue(int borneX, int blueCylSurf, int bord, boolean gauche){
		int[] posBlueCylinder = RobotTools.foundBlueCylinderFromBlue(mainBuffImg,borneX,blueCylSurf,bord,gauche);
		return posBlueCylinder;
	}
	
	
	public int[] foundRobot(int minRobotSize, int robotBord){
		int[] posRobot = RobotTools.foundRobot(mainBuffImg, minRobotSize, robotBord);
		return posRobot;
	}
	
	public int[] foundRobotTop(int maxRobotSize, int[] posRobot){
		int[] avant = RobotTools.foundRobotTop(mainBuffImg, maxRobotSize, posRobot);
		return avant;
	}
	
	public int[][] foundRobotOrientation(int maxRobotSize, int[] posRobot){
		int[][] posCoin = RobotTools.foundRobotOrientation(mainBuffImg, maxRobotSize, posRobot);
		return posCoin;
	}
	
	public void selectColor(int noColor, int seuilMin, int seuilMax){
		mainBuffImg = ImageTools.selectColor(mainBuffImg, noColor, seuilMin, seuilMax);
	}

	public int[] foundWall(int decalageX,int decalageY, boolean gauche){
		int[] wall = RobotTools.foundWall(mainBuffImg,decalageX,decalageY,gauche);
		return wall;
	}

	public int[][] foundDoor(int maxLargHorizWall, int maxLargVertWall, int[] wallPos, boolean gauche){
		int[][] doors = RobotTools.foundDoor(mainBuffImg,maxLargHorizWall,maxLargVertWall, wallPos, gauche);
		return doors;
	}

	public void searchImage(int dimX, int dimY, int[]comparePixelTab){
	}
	
	public void selectColor(int tolerance){
	}
	

	
	public void ReQuantify(int nbBits, boolean isTruncation){
	}
	

}
