/* EHRLER FREDERIC - MICHEL DERIAZ
 * ------------------------------------------------------------------
 * cette classe s'occupe de demander au differentes images d'appliquer
 * les traitement, d'effectuer une recherche ou encore d'afficher 
 * les objets sur l'image. Cette classe n'est donc qu'une interface
 * pour acceder au differentes images.
 *
 */
 


import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.awt.image.*;
import java.io.*;

public class ImageAnalyserJAI{
	Vector analysedImage;
	int nbImage = 12;
	int decalcage = 1;
	int[] wall;
	int[][] doors;
	int[] posRedCylinder;
	int[] posBlueCylinder;
	int[] posGreenCylinder;
	int[] posRobot;
	int[] avantRobot;
	int[][] coinRobot;
	int[] RobotGCenter;
	double angleRobot;
	ParamDistributor param;
	
	public ImageAnalyserJAI(){
		analysedImage = new Vector();
	}
	
	public ImageAnalyserJAI(Image img){
		analysedImage = new Vector();
		analysedImage.add(new AnalysedImageJAI(img));
	}
	
	public void changeImage(Image img){
		analysedImage.removeAllElements();
		analysedImage.add(new AnalysedImageJAI(img));
	}
	
	public void applyEffect(ParamDistributor param){
		this.param = param;
		if (param.getGamma() != 1){
			((AnalysedImageJAI)analysedImage.get(0)).correctGamma(param.getGamma());
			
		}
		
		if (param.getFilter()){
			System.out.println("passage "+param.getNbPasse()+" fois du filtre de taille "+param.getTailleFiltre());
			((AnalysedImageJAI)analysedImage.get(0)).filter(param.getNbPasse(),param.getTailleFiltre());
		}
		
		
		if (param.getBorder()){
			System.out.println("application d'une bordure");
			((AnalysedImageJAI)analysedImage.get(0)).applyBorder(param.getBorderSize(),param.getBorderValue());
		}
		
		BufferedImage buffImg = ((AnalysedImageJAI)analysedImage.get(0)).getTransformImage();
		analysedImage.removeAllElements();

		for (int i=0; i<nbImage; i++){
			analysedImage.add(new AnalysedImageJAI(buffImg));
		}		
/*		for (int i=1; i<analysedImage.size();i++){
				((AnalysedImageJAI)analysedImage.get(i)).setTransformImage(buffImg);
		}	
*/	

		if (param.isCalculatedImage(1+decalcage)){
			((AnalysedImageJAI)analysedImage.get(1)).noireBlanc();
			((AnalysedImageJAI)analysedImage.get(1)).binarize(param.getBWSeuil());
		}
		if (param.isCalculatedImage(2+decalcage)){
			((AnalysedImageJAI)analysedImage.get(2)).getBand(0);
			((AnalysedImageJAI)analysedImage.get(2)).noireBlanc();
			((AnalysedImageJAI)analysedImage.get(2)).binarize(param.getRSeuil());
		}
		if (param.isCalculatedImage(3+decalcage)){
			((AnalysedImageJAI)analysedImage.get(3)).getBand(1);
			((AnalysedImageJAI)analysedImage.get(3)).noireBlanc();
			((AnalysedImageJAI)analysedImage.get(3)).binarize(param.getGSeuil());
		}
		if (param.isCalculatedImage(4+decalcage)){
			((AnalysedImageJAI)analysedImage.get(4)).getBand(2);
			((AnalysedImageJAI)analysedImage.get(4)).noireBlanc();
			((AnalysedImageJAI)analysedImage.get(4)).binarize(param.getBSeuil());
		}


		if (param.getRescale()){
			((AnalysedImageJAI)analysedImage.get(2)).rescale();
			((AnalysedImageJAI)analysedImage.get(3)).rescale();
			((AnalysedImageJAI)analysedImage.get(4)).rescale();
		}
		
		((AnalysedImageJAI)analysedImage.get(5)).selectColorOperator(param.getColorOpDiff() ,param.getColorOpMinSeuil());
		((AnalysedImageJAI)analysedImage.get(6)).selectAllColor(param.getBlackValue());
		
		int[] selectColorSeuilR = param.getSelectColorSeuilR();
		int[] selectColorSeuilG = param.getSelectColorSeuilG();
		int[] selectColorSeuilB = param.getSelectColorSeuilB();
		System.out.println("selectColorSeuilR := "+selectColorSeuilR[0]+";"+selectColorSeuilR[1]);
		((AnalysedImageJAI)analysedImage.get(8)).selectColor(0,selectColorSeuilR[0],selectColorSeuilR[1]);
		((AnalysedImageJAI)analysedImage.get(9)).selectColor(1,selectColorSeuilG[0],selectColorSeuilG[1]);
		((AnalysedImageJAI)analysedImage.get(10)).selectColor(2,selectColorSeuilB[0],selectColorSeuilB[1]);
		
		if (param.getRequestWall()){
			wall = ((AnalysedImageJAI)analysedImage.get(3)).foundWall(param.getDecalageX(), param.getDecalageY(), param.getGauche());
			doors = ((AnalysedImageJAI)analysedImage.get(3)).foundDoor(param.getLargMaxDoorHoriz(), param.getLargMaxDoorVert(), wall, param.getGauche());
		}
		if (param.getRequestRed()){
			posRedCylinder = ((AnalysedImageJAI)analysedImage.get(6)).foundRedCylinder(wall[0], param.getRedCylSurf(), param.getRedBord(), param.getGauche());
		}
		
		if (param.getRequestBlue()){
			//posBlueCylinder = ((AnalysedImageJAI)analysedImage.get(6)).foundBlueCylinder(wall[0], param.getBlueCylSurf(), param.getBlueBord(), param.getGauche());
			posBlueCylinder = ((AnalysedImageJAI)analysedImage.get(10)).foundBlueCylinderFromBlue(wall[0], param.getBlueCylSurf(), param.getBlueBord(), param.getGauche());
		}
		
		if (param.getRequestGreen()){
			//posGreenCylinder = ((AnalysedImageJAI)analysedImage.get(6)).foundGreenCylinder(wall[0], param.getGreenCylSurf(), param.getGreenBord(), param.getGauche());
			posGreenCylinder = ((AnalysedImageJAI)analysedImage.get(9)).foundGreenCylinderFromGreen(wall[0], param.getGreenCylSurf(), param.getGreenBord(), param.getGauche(),posBlueCylinder);
		}

		if (param.getRequestRobot()){
			posRobot = ((AnalysedImageJAI)analysedImage.get(6)).foundRobot(param.getMinRobotSize(), param.getRobotBord());
			avantRobot = ((AnalysedImageJAI)analysedImage.get(6)).foundRobotTop(param.getMaxRobotSize(), posRobot);
			coinRobot = ((AnalysedImageJAI)analysedImage.get(6)).foundRobotOrientation(param.getMaxRobotSize(), posRobot);
		}	
		
		if (param.getQuadrillage()){
			((AnalysedImageJAI)analysedImage.get(7)).drawQuadrillage();
		}
		
		RobotGCenter = GeomTools.getGravityCenter(coinRobot);
		System.out.println("centre de gravit calcul := "+RobotGCenter[0]+";"+RobotGCenter[1]);
		
		//angleRobot = Math.toDegrees(GeomTools.calculateAngleBetween(RobotGCenter, avantRobot));
		
		((AnalysedImageJAI)analysedImage.get(7)).drawWall(wall, param.getGauche());
		((AnalysedImageJAI)analysedImage.get(7)).drawDoor(wall, doors);
		((AnalysedImageJAI)analysedImage.get(7)).drawCylinder(posRedCylinder,param.getRedCylSurf(), posGreenCylinder, param.getGreenCylSurf(), posBlueCylinder,param.getBlueCylSurf());
		((AnalysedImageJAI)analysedImage.get(7)).drawRobot(posRobot, param.getRobotSizeX(),param.getRobotSizeY());
		((AnalysedImageJAI)analysedImage.get(7)).drawRobot(coinRobot);
		((AnalysedImageJAI)analysedImage.get(7)).drawTopRobot(avantRobot);
		((AnalysedImageJAI)analysedImage.get(7)).drawRobotOrientation(RobotGCenter, avantRobot);
		
		((AnalysedImageJAI)analysedImage.get(11)).substract(((AnalysedImageJAI)analysedImage.get(1)).getTransformImage(), ((AnalysedImageJAI)analysedImage.get(3)).getTransformImage());
	}

	public void reset(){
	}
	
	public Terrain getNewTerrain(Image img){
		Terrain terrain = new Terrain();
		terrain.setCylindreDiameter(param.getRedCylSurf());
		terrain.setWallPos(wall);
		terrain.setRedCylPos(posRedCylinder);
		terrain.setGreenCylPos(posGreenCylinder);
		terrain.setBlueCylPos(posBlueCylinder);
		terrain.setCoinRobot(coinRobot);
		terrain.setTopPoint(avantRobot);
		terrain.setDoors(doors);
		return terrain;
	}
	
	
	/*public BufferedImage getFinalImage(){
		return analysedImageJAI.getTransformImage();
	}*/
	
	public Vector getFinalImage(){
		return analysedImage;
	}
	
	
	
}