/* EHRLER FREDERIC - MICHEL DERIAZ
 * ------------------------------------------------------------------
 * cette classe est celle qui va interagire avec la camera, elle va
 * detecter les differents driver present sur la machine et va 
 * selectionner celui qui est apprie. Une fois la connexion a la 
 * camera etablie, on pourra demander des image lorsque necessaire
 * grace a la methode getImage().
 */
import java.io.*;
import java.awt.*;
import java.net.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.Vector; 
import javax.media.*;
import javax.media.rtp.*;
import javax.media.rtp.event.*;
import javax.media.rtp.rtcp.*;
import javax.media.protocol.*;
import javax.media.protocol.DataSource;
import javax.media.format.AudioFormat;
import javax.media.format.VideoFormat;
import javax.media.Format;
import javax.media.format.FormatChangeEvent;
import javax.media.control.BufferControl; 
import javax.media.control.*;
import javax.media.util.*;


public class ImageDistributor implements ActionListener{ 
	private static String defaultVideoDeviceName = "Microsoft WDM Image Capture";
	private static String defaultVideoFormatString = "176x144";
	private static CaptureDeviceInfo captureVideoDevice = null;
	private static VideoFormat captureVideoFormat = null;
	FrameGrabbingControl grabberControl;
	BufferToImage bufferToImg;
	Player player = null;
	RTPManager mgrs[] = null;
	int bticheck = 0;
	Buffer buf = null;
	BufferToImage bti = null;
	
	public static void main(String args[]){
		new ImageDistributor();
	}
		
	public ImageDistributor(){
		System.out.println("get list of all media devices ...");
		Vector deviceListVector = CaptureDeviceManager.getDeviceList(null);
		if (deviceListVector == null){
			System.out.println("... error: media device list vector is null, program aborted");
			System.exit(0);
		}
		if (deviceListVector.size() == 0){
			System.out.println("... error: media device list vector size is 0, program aborted");
			System.exit(0);
		}
 		for (int x = 0; x < deviceListVector.size(); x++){
		// display device name
			CaptureDeviceInfo deviceInfo = (CaptureDeviceInfo) deviceListVector.elementAt(x);
			String deviceInfoText = deviceInfo.getName();
			//System.out.println("\n\n\n device " + x + ": " + deviceInfoText); 
			
			if (deviceInfoText.indexOf(defaultVideoDeviceName) >= 0){
				captureVideoDevice = deviceInfo;
				MediaLocator locator = captureVideoDevice.getLocator();
				//System.out.println("location du device: " + locator.toString());
				//System.out.println(">>> capture video device = " + captureVideoDevice.getName());
			
				// display device formats
				Format deviceFormat[] = deviceInfo.getFormats();
			
				for (int y = 0; y < deviceFormat.length; y++){ 
					if (deviceFormat[y] instanceof VideoFormat){
						String deviceFormatText = deviceFormat[y].toString();
						//System.out.println("\ndevice instance of videoformat");
						//System.out.println("device format: "+deviceFormatText);
						if (deviceFormatText.indexOf(defaultVideoFormatString) >= 0){
							captureVideoFormat = (VideoFormat)deviceFormat[y];
							System.out.println(">>> capture video format = " + deviceFormatText);
						}
						
					}
					
				}
			} 
		}
		// setup video data source
		// -----------------------
		MediaLocator videoMediaLocator = captureVideoDevice.getLocator();
		DataSource videoDataSource = null;
		try{
			videoDataSource = javax.media.Manager.createDataSource(videoMediaLocator);
		}
		catch (IOException ie) { 
			System.out.println(ie); 
		}
		catch (NoDataSourceException nse) { 
			System.out.println(nse);
		}
		
		// create a new processor
		// ----------------------

		// setup output file format  ->> msvideo
		FileTypeDescriptor outputType = new FileTypeDescriptor(FileTypeDescriptor.MSVIDEO);

		// setup output video and audio data format
		Format outputFormat[] = new Format[1];
		outputFormat[0] = new VideoFormat(VideoFormat.RGB);
		//outputFormat[0] = new VideoFormat(VideoFormat.JPEG);

		bufferToImg = new BufferToImage((VideoFormat)outputFormat[0]);
		// create processor
		ProcessorModel processorModel = new ProcessorModel(videoDataSource, outputFormat, outputType);
		Processor processor = null;
		try
		{
			processor = Manager.createRealizedProcessor(processorModel);
		}
		catch (IOException e) { System.out.println("e"); }
		catch (NoProcessorException e) { System.out.println(e); }
		catch (CannotRealizeException e) { System.out.println(e); }

		// get the output of the processor
		DataSource source = processor.getDataOutput();
	
		player = null;
		try	{
			player = Manager.createPlayer(videoDataSource);
		}
		catch (IOException e) { System.out.println("player ??? "+e); }
		catch (NoPlayerException e) { System.out.println(e); }



		Control[] listeControl = player.getControls();
		System.out.println("nombre de controle := "+listeControl.length);

		grabberControl = (FrameGrabbingControl)player.getControl("javax.media.control.FrameGrabbingControl");
		if (grabberControl == null){
			System.out.println("grabberControl inexisant");
		} else{
			System.out.println("grabberControl coorecte");
			Buffer buf = grabberControl.grabFrame();
		}
		
		System.out.println("liste des controle");
		for (int i=0; i<listeControl.length; i++){
			System.out.println(listeControl[i].getClass());
		}
		
		
		System.out.println("actual player rate "+player.getRate());
		Float rate = new Float(2.0);
		
		
		player.realize();
		player.addControllerListener(new ControllerAdapter(){
			public void realizeComplete(RealizeCompleteEvent e){
				System.out.println("player realized");
				suite();
			}
		});
	}	
		
		/*MediaPlayer mediaPlayer = new MediaPlayer();
		mediaPlayer.setPlayer(player);
		//mediaPlayer.realize();
		*/
		
	public Image getFrame() {
    	buf = grabberControl.grabFrame();
   		if (bticheck==0) {
     		bti = new BufferToImage((VideoFormat)buf.getFormat());
     	 	bticheck=1;
    	}	
    	//Umwandlung des Frames in ein Image
    	if (buf.getFormat()!=null) {
    		Image image = bti.createImage(buf);
    		return image;
		}
    	else {
    		return null;
    	}
    }	
		
		
	public void suite(){
		Control[] listeControl = player.getControls();
		System.out.println("nombre de controle := "+listeControl.length);
		grabberControl = (FrameGrabbingControl)player.getControl("javax.media.control.FrameGrabbingControl");
		if (grabberControl == null){
			System.out.println("grabberControl inexisant");
		} else{
			System.out.println("grabberControl correcte");
		}
		
		System.out.println("liste des controle");
		for (int i=0; i<listeControl.length; i++){
			System.out.println(listeControl[i].getClass());
		}
		
		JFrame fenetre = new JFrame("video");
		JFrame fenetre2 = new JFrame("bouton");
		JPanel mainPanel = new JPanel();
		JPanel mainPanel2 = new JPanel();
		JButton bouton1 = new JButton("getImg");
		mainPanel.add(player.getVisualComponent());
		
		
		bouton1.addActionListener(this);
		
		mainPanel2.setLayout(new BorderLayout(5,5));
		mainPanel2.add(player.getControlPanelComponent(),BorderLayout.NORTH);
		mainPanel2.add(bouton1,BorderLayout.SOUTH);
		
		
		
		fenetre.setContentPane(mainPanel);
		fenetre2.setContentPane(mainPanel2);
		fenetre.pack();
		fenetre2.pack();
		//fenetre.setSize(400,400);
		fenetre.show();
		fenetre2.show();
		player.start();
		System.out.println("all ok");
	}
	
	
	public Image getImage(){
		Image img = getFrame();
		return img;
	}
	
	public void actionPerformed(ActionEvent e){
		Image img = getFrame();
		
		if (img == null){
			System.out.println("pas d'image");
		} else{
			System.out.println("image capturee");
		}
		

		JFrame fenetre3 = new JFrame("image");
		fenetre3.setContentPane(new AfficheImg(img));
		fenetre3.pack();
		fenetre3.show();

	}
	
/*
	Buffer buf = grabberControl.grabFrame(); 
	if (bti == null || !buf.getFormat().equals(lastSnapFormat)) {
   		bti = new BufferToImage((VideoFormat)buf.getFormat());
   		lastSnapFormat = buf.getFormat();
    }
	Image im = null;
	im = bti.createImage(buf);
*/	
	
		//mediaPlayer.setRate(rate.floatValue());
	
	
	
/*		
		JPanel mainPanel = new JPanel();
		JPanel buttonPanel = new JPanel();
		JButton bouton1 = new JButton("getImage");
		buttonPanel.add(bouton1);
		ButtonListener buttonListener = new ButtonListener(this);
		bouton1.addActionListener(buttonListener);
		mainPanel.setLayout(new BorderLayout(5,5));
		mainPanel.add(buttonPanel,BorderLayout.NORTH);
		//mainPanel.add(player.getVisualComponent(),BorderLayout.SOUTH);
		//mainPanel.add(buttonPanel,BorderLayout.SOUTH);
		//fenetre.setContentPane(mainPanel);
		fenetre2.setContentPane(buttonPanel);
		fenetre2.pack();
		fenetre2.show();
		fenetre.setContentPane(mediaPlayer);
		fenetre.pack();
		fenetre.setSize(400,400);
		fenetre.show();
		player.start();
*/		
/*		// create a File protocol MediaLocator with the location
		// of the file to which bits are to be written
		MediaLocator dest = new MediaLocator("file:testcam.avi");

		// create a datasink to do the file
		DataSink dataSink = null;
		MyDataSinkListener dataSinkListener = null;
		try
		{
			dataSink = Manager.createDataSink(source, dest);
			dataSinkListener = new MyDataSinkListener();
			dataSink.addDataSinkListener(dataSinkListener);
			dataSink.open();
		}
		catch (IOException e) { System.out.println("e"); }
		catch (NoDataSinkException e) { System.out.println("e"); }
		catch (SecurityException e) { System.out.println("e"); }

		// now start the datasink and processor
		try
		{
			dataSink.start();
		}
		catch (IOException e) { System.out.println("e"); }
		processor.start();

		System.out.println("starting capturing ...");
		try { Thread.currentThread().sleep(10000); } catch (InterruptedException ie) {}	// capture for 10 seconds
		System.out.println("... capturing done");

		// stop and close the processor when done capturing...
		// close the datasink when EndOfStream event is received...
		processor.stop();
		process()or.close();

		dataSinkListener.waitEndOfStream(10);
		dataSink.close();
		
	}
	*/
}