/* EHRLER FREDERIC - MICHEL DERIAZ
 * ------------------------------------------------------------------
 * cette classe possede tout les outils pour le reperage des objets
 * a detecter sur l'image, c'est a dire les murs, les porte, les 
 * cylindre et les differente partie du robot.
 *
 */
 
 
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.awt.image.*;
import java.awt.image.renderable.*;
import javax.media.jai.*;
import com.sun.media.jai.codec.*;
import java.awt.color.*;


public class RobotTools{


/* OPERATEUR FOUND DOOR
 * -------------------------------------------------------------------------
 * pour trouver la porte on va parcourir le mur en longueur, et si 
 * la largueur du mur est plus mince qu'un certain seuil au aura alors
 * les position de la porte.
 */
	public static int[][] foundDoor(BufferedImage buffImgSource,int largeurMaxHoriz,int largeurMaxVert, int[] wallPos, boolean gauche){
	  int w = buffImgSource.getWidth(null);
    int h = buffImgSource.getHeight(null);
    BufferedImage buffImgDest = new BufferedImage(w, h, BufferedImage.TYPE_INT_ARGB);
    int debutX;
    int finX;
    int largeur;
    int debutPorteHoriz;
    int finPorteHoriz;
    int debutPorteVert;
    int finPorteVert;
    int[][] posPorte = new int[2][2];
    int bord = 10; 
     
    System.out.println("recherche des portes =====================================>");
 		
 		debutPorteVert = 240;
 		finPorteVert = 0;

 		if (gauche) {
 			debutX = 0+bord;
 			debutPorteHoriz =wallPos[0];
 			finX = wallPos[0]-bord;
 			finPorteHoriz =0;
 		} else {
 			debutX = wallPos[0]+bord;
 			debutPorteHoriz = 320;
 			finX = 320-bord;
 			finPorteHoriz = wallPos[0];
 		}
 		
 		for (int i=debutX ; i<finX; i++) {
   		largeur = 0;
   		for (int j = wallPos[1]-10; j < wallPos[1]+10; j++) {
    		if ((i<320)&&(j<240)&&(i>0)&&(j>0)){
    			int pixelColor = buffImgSource.getRGB(i, j);
					int red   = (int)((pixelColor >> 16) & 0xff); 
     			int green = (int)((pixelColor >> 8 ) & 0xff);
 					int blue  = (int)((pixelColor      ) & 0xff); 
  				if ((red==0) && (green ==0) && (blue == 0)){
  					largeur += 1;
  				}
  			}
  		}
  		//System.out.println("largeur a pos i= "+i+" := "+largeur);
  		if (largeur<largeurMaxHoriz){
  			if (i<debutPorteHoriz){
  				debutPorteHoriz=i;
  			}
  			if (i>finPorteHoriz){
  				finPorteHoriz=i;
  			}
  		}
		}	  
// ----------------------------------------------------------		
		for (int j = 0+bord; j < 240-bord; j++) {		
			largeur = 0;				
			for (int i=wallPos[0]-10 ; i<wallPos[0]+10; i++) {
				if ((i<320)&&(j<240)&&(i>0)&&(j>0)){
    			int pixelColor = buffImgSource.getRGB(i, j);
				int red   = (int)((pixelColor >> 16) & 0xff); 
     			int green = (int)((pixelColor >> 8 ) & 0xff);
 				int blue  = (int)((pixelColor      ) & 0xff); 
  				if ((red==0) && (green ==0) && (blue == 0)){
  					largeur += 1;
  				}
  			}
  		}
  		//System.out.println("largeur a pos j= "+j+" := "+largeur);
  		if (largeur<largeurMaxVert){
  			if (j<debutPorteVert){
  				debutPorteVert=j;
  			}
  			if (j>finPorteVert){
  				finPorteVert=j;
  			}
  		}
  	}
  	posPorte[0][0] = debutPorteHoriz;
  	posPorte[0][1] = finPorteHoriz;
  	posPorte[1][0] = debutPorteVert;
  	posPorte[1][1] = finPorteVert;
				
	System.out.println("debut porteHoriz := "+debutPorteHoriz+" fin  := "+finPorteHoriz);
	System.out.println("debut porteVert := "+debutPorteVert+" fin  := "+finPorteVert);
		
	return posPorte;
	}	


/* OPERATEUR FOUND WALL
 * ------------------------------------------------------------------------
 * recherche des murs, on parcours le terrain depuis une position decalee
 * du mileu. On commence par un parcours horizontal, afin de trouver le mur 
 * vertical que l'on placera des lors qu'on tombe sur une intersection 
 * avec un pixel noir.
 * pour le mur horizontal, le decalage sera different selon qu'on le 
 * recherche a gauche ou a droite, mais le reste est le similaire, on 
 * parcours verticalement depuis la position jusqu'a une intersection avec
 * un pixel noir.
 */
	public static int[] foundWall(BufferedImage buffImgSource, int decX, int decY, boolean gauche){
	    int w = buffImgSource.getWidth(null);
	    int h = buffImgSource.getHeight(null);
	    int middleX = w/2;
	    int middleY = h/2;
	    int depX = middleX-decX;
	    int depY = middleY-decY;
	    int stopX = middleX-decX;
	    int stopY = middleY-decY;
	    BufferedImage buffImgDest = new BufferedImage(w, h, BufferedImage.TYPE_INT_ARGB);
	    boolean noCross;
	    int i;
	    int j;
	    int posVerticalWall = 0;
	    int posHorizWall = 0;
	    
	// recherche du mur verticale		    
	    System.out.println("recherche des murs =====================================>");
	    System.out.println("depX := "+depX+" depY := "+depY);
	    noCross = true;
	    i = depX;
	    while(noCross){
	    	i = i+1;
	   	   	int pixelColor = buffImgSource.getRGB(i, middleY);
	   	   	int red   = (int)((pixelColor >> 16) & 0xff); 
			if (red==0) {
				posVerticalWall = i;
				noCross = false;
			}
		}
			
		int decalage=0;
		if (gauche){
			decalage = -40;
		} else{
			decalage = 40;
		}	
		
	// recherche du mur horizontal	
		noCross = true;
		j = depY;
		while(noCross){
	    	j = j+1;
	    	int pixelColor = buffImgSource.getRGB(posVerticalWall+decalage, j);
	      	int red   = (int)((pixelColor >> 16) & 0xff); 
		  	if (red==0) {
				posHorizWall = j;
				noCross = false;
			}
		}
			
		int[] result = new int[2];
		result[0]=posVerticalWall;
		result[1]=posHorizWall;
			
		System.out.println("horiz pos := "+posVerticalWall+" vertical pos := "+posHorizWall);
		return result;
	}	
	
/* OPERATEUR GETAVANTROBOT	
 * -------------------------------------------------------------------------
 * pour trouver l'avant du robot, on a ace moment la connaissance de la 
 * position de l'arriere. On va donc a partir de cette position faire une
 * recherche sur un pattern noir et jaune. Pour ce faire, on va en faite
 * rechercher une position ou la somme des pixels noirs et jaunes est la 
 * plus proche possible, tout en ajoutant une penalit si l'on tombe sur
 * un pixel blanc.
 */
	public static int[] foundRobotTop(BufferedImage buffImgSource, int robotMaxSize, int[] robotPos){
    int w = buffImgSource.getWidth(null);
    int h = buffImgSource.getHeight(null);
    BufferedImage buffImgDest = new BufferedImage(w, h, BufferedImage.TYPE_INT_ARGB);
    int depX;
    int depY;
    int finX;
    int finY;
    int sumNeighbor = 0;
    int[] posRobot = new int[2];
    int controlSurface = robotMaxSize;
    int nbYellowNeighbor = 2;

   	depX = robotPos[0]-10;
   	depY = robotPos[1]-10;
    finX = depX+controlSurface;
    finY = depY+controlSurface;
    
    System.out.println("analyse de l'avant du robot =======================================");
    System.out.println("==================================================================");
    System.out.println("pos Robot := "+robotPos[0]+";"+robotPos[1]);
    System.out.println("depart de la recherche: "+depX+";"+depY+" jusqu'a "+finX+";"+finY);
	
    int SumBlack=0;
    int SumYellow=0;
    int SumWhite=0;
    int minAvant = 1000000000;
    int posAvantX = 0;
    int posAvantY = 0;
    
    for (int i=depX-10 ; i<finX+10; i++) {
      for (int j = depY-10; j < finY+10; j++) {
      	if ((i<320)&&(j<240)&&(i>0)&&(j>0)){
      		int pixelColor = buffImgSource.getRGB(i, j);
 			int red   = (int)((pixelColor >> 16) & 0xff); 
       		int green = (int)((pixelColor >> 8 ) & 0xff);
   			int blue  = (int)((pixelColor      ) & 0xff); 
	  		if ((red==0xff) && (green ==0xff) && (blue == 0)){
	  			//System.out.println("test du pixels "+i+";"+j);
	  			SumBlack=0;
    			SumYellow=0;
    			SumWhite=0;
	  			for (int k=i-10; k<i+10; k++){
	  				for (int l=j-nbYellowNeighbor; l<j+nbYellowNeighbor; l++){
	  					if ((k<320)&&(l<240)&&(k>0)&&(l>0)){
	  						pixelColor = buffImgSource.getRGB(k, l);
	  						red   = (int)((pixelColor >> 16) & 0xff); 
	  						green = (int)((pixelColor >> 8 ) & 0xff);
   							blue  = (int)((pixelColor      ) & 0xff); 
	  						//System.out.println("red:= "+red);
	  						if ((red==0) && (green ==0) && (blue == 0)){
	  							SumBlack	= SumBlack+255;
	  						}
	  						if ((red==0xff) && (green ==0xff) && (blue == 0)){
	  							SumYellow	= SumYellow+255;
	  						}
	  						if ((red==0xff) && (green ==0xff) && (blue == 0xff)){
	  							SumWhite	= SumWhite+255;
	  						}
	  					}
	  				}
	  			}
	  			if ((((Math.abs(SumYellow-SumBlack))+SumWhite)<minAvant)){//&&(SumYellow>6000)&&(SumBlack>6000)){
	  				System.out.println("SumYellow("+i+","+j+") := "+SumYellow);
		  			System.out.println("SumBlack("+i+","+j+") := "+SumBlack);
		  			System.out.println("SumWhite("+i+","+j+") := "+SumWhite);
	  				minAvant=Math.abs(SumYellow-SumBlack)+SumWhite;
	  				posAvantX = i;
	  				posAvantY = j;
	  			}
	  		}			
	  	}
	  }
	}		
	System.out.println("posAvantX:= "+posAvantX+" posAvantY:= "+posAvantY);
	int[] avant = new int[2];
	avant[0] = posAvantX;
	avant[1] = posAvantY;
	return avant; 
	}				   
    
	
	
/* OPERATEUR FOUND ROBOT ORIENTATION
 * ---------------------------------------------------------------------------
 * cette methode ne donne en faite pas l'orientation du robot, mais elle va 
 * indiquer les extremite du robot. On connais a ce moment les coordonnee 
 * du robot, on va parcourir les alentour et trouver le max et min en y et x
 * des position des valeurs de jaune trouvee, on connaitera ainsi les point
 * des extreme du robot.
 */
	public static int[][] foundRobotOrientation(BufferedImage buffImgSource, int robotMaxSize, int[] robotPos){
    int w = buffImgSource.getWidth(null);
    int h = buffImgSource.getHeight(null);
    BufferedImage buffImgDest = new BufferedImage(w, h, BufferedImage.TYPE_INT_ARGB);
    int depX;
    int depY;
    int finX;
    int finY;
    int sumNeighbor = 0;
    int[] posRobot = new int[2];
    int controlSurface = robotMaxSize;
    int nbYellowNeighbor = 2;
    int maxTopX = 0;
    int maxTopY = 0;
    int minTopX = 320;
    int minTopY = 240;
    int maxDownX = 0;
    int maxDownY = 0;
    int minDownX = 320;
    int minDownY = 240;
    int[] coinMaxX = new int[2];
    int[] coinMinX = new int[2];
    int[] coinMaxY = new int[2];
    int[] coinMinY = new int[2];
    int[] coinDown1 = new int[2];
    int[] coinDown2 = new int[2];
    int[] coinDown3 = new int[2];
    int[] coinDown4 = new int[2];
    int[][] allcoinTop = new int[4][2];
        
   	depX = robotPos[0]-10;
   	depY = robotPos[1]-10;
    finX = depX+controlSurface;
    finY = depY+controlSurface;
    
    System.out.println("analyse de la pos du robot =======================================");
    System.out.println("==================================================================");
    System.out.println("pos Robot := "+robotPos[0]+";"+robotPos[1]);
    System.out.println("depart de la recherche: "+depX+";"+depY+" jusqu'a "+finX+";"+finY);
	

    for (int i=depX ; i<finX; i++) {
      for (int j = depY; j < finY; j++) {
      	if ((i<320)&&(j<240)&&(i>0)&&(j>0)){
      		int pixelColor = buffImgSource.getRGB(i, j);
 			int red   = (int)((pixelColor >> 16) & 0xff); 
       		int green = (int)((pixelColor >> 8 ) & 0xff);
   				int blue  = (int)((pixelColor      ) & 0xff); 
	  			if ((red==0xff) && (green ==0xff) && (blue == 0)){
	  				//System.out.println("test du pixels "+i+";"+j);
	  				sumNeighbor = 0;
	  				for (int k=i-nbYellowNeighbor; k<i+nbYellowNeighbor; k++){
	  					for (int l=j-nbYellowNeighbor; l<j+nbYellowNeighbor; l++){
	  						if ((k<320)&&(l<240)&&(k>0)&&(l>0)){
	  							pixelColor = buffImgSource.getRGB(k, l);
	  							red   = (int)((pixelColor >> 16) & 0xff); 
	  							green = (int)((pixelColor >> 8 ) & 0xff);
   								blue  = (int)((pixelColor      ) & 0xff); 
	  							//System.out.println("red:= "+red);
	  							sumNeighbor = sumNeighbor+255*2-red-green;
	  						}
	  					}
	  				}


  					if (i>maxTopX){
	  					maxTopX = i;
	  					coinMaxX[0]=i;
	  					coinMaxX[1]=j;
	  				}
	  				if (i<minTopX){
	  					minTopX = i;
	  					coinMinX[0]=i;
	  					coinMinX[1]=j;
	  				}
	  				if (j>maxTopY){
	  					maxTopY = j;
	  					coinMaxY[0]=i;
	  					coinMaxY[1]=j;
	  				}
	  				if (j<minTopY){
	  					minTopY = j;
	  					coinMinY[0]=i;
	  					coinMinY[1]=j;
	  				}
	  			}
			}
		}
	}
	allcoinTop[0][0] = coinMaxX[0];
	allcoinTop[0][1] = coinMaxX[1];
	allcoinTop[1][0] = coinMinX[0];
	allcoinTop[1][1] = coinMinX[1];
	allcoinTop[2][0] = coinMaxY[0];
	allcoinTop[2][1] = coinMaxY[1];
	allcoinTop[3][0] = coinMinY[0];
	allcoinTop[3][1] = coinMinY[1];
		
	return allcoinTop;
}
	
	
	
/* OPERATOR FOUNDROBOT	
 * ---------------------------------------------------------------------------
 * c'est cette methode qui nous retourne la position du robot. On va 
 * parcourir toute limage et des lors que l'on tombe sur un pixel jaune, on
 * regarde les pixels alentour, si l'on tombe sur une surface jaune de 
 * taille consistante, cela signifie que l'on a trouve le robot. On a un
 * systeme de ponderation qui nous permet d'affiner la recherche, en plus
 * de trouver une surface jaune, il faut que les pixels voisins soient 
 * blanc.
 */
	public static int[] foundRobot(BufferedImage buffImgSource, int robotMinSize, int bord){
    int w = buffImgSource.getWidth(null);
    int h = buffImgSource.getHeight(null);
    BufferedImage buffImgDest = new BufferedImage(w, h, BufferedImage.TYPE_INT_ARGB);
    int depX;
    int stopX;
    int sumNeighborMax;
    int sumNeighborMin;
    int[] posRobot = new int[2];
    int controlSurface = robotMinSize;
    int maxSumNeighbor = 0;
    
   	depX = 0+bord;
    stopX = 320-bord;

    System.out.println("analyse du robot jaune :===============================");
    for (int i=depX ; i<stopX; i++) {
      for (int j = 0+bord; j < h-bord; j++) {
        int pixelColor = buffImgSource.getRGB(i, j);
       	int red   = (int)((pixelColor >> 16) & 0xff); 
       	int green = (int)((pixelColor >> 8 ) & 0xff);
   			int blue  = (int)((pixelColor      ) & 0xff); 
	  		if ((red==0xff) && (green ==0xff) && (blue == 0)){
	  			sumNeighborMax = 0;
	  			sumNeighborMin = 0;
	  			if ((i<320-(controlSurface+1))&&(j<240-(controlSurface+1))){
	  				// controle des voisin
	  				//System.out.println("pos "+i+";"+j);
	  				for (int k=i; k<i+controlSurface; k++){
	  					for (int l=j; l<j+controlSurface; l++){
	  						pixelColor = buffImgSource.getRGB(k, l);
	  						red   = (int)((pixelColor >> 16) & 0xff); 
	  						green = (int)((pixelColor >> 8 ) & 0xff);
   							blue  = (int)((pixelColor      ) & 0xff); 
	  						//System.out.println("red:= "+red);
	  						sumNeighborMax = sumNeighborMax+(red+green-1*blue);
	  					}
	  				}
	  				/////////////////////////////////////////////////////////////////
	  				
	  				for (int k=i+controlSurface; k<i+1.5*controlSurface; k++){
	  					for (int l=j-(int)(0.5*controlSurface); l<j+1.5*controlSurface; l++){
	  						if ((k<320)&&(l<240)&&(k>0)&&(l>0)){
	  							pixelColor = buffImgSource.getRGB(k, l);
	  							red   = (int)((pixelColor >> 16) & 0xff); 
	  							green = (int)((pixelColor >> 8 ) & 0xff);
   								blue  = (int)((pixelColor      ) & 0xff); 
	  							//System.out.println("red:= "+red);
	  							sumNeighborMin = sumNeighborMin-red-green-blue;
	  						} else {
	  							sumNeighborMin = sumNeighborMin+255;
	  						}
	  					}
	  				}
	  				
	   				for (int k=i-(int)(0.5*controlSurface); k<i; k++){
	  					for (int l=j-(int)(0.5*controlSurface); l<j+1.5*controlSurface; l++){
	  						if ((k<320)&&(l<240)&&(k>0)&&(l>0)){
	  							pixelColor = buffImgSource.getRGB(k, l);
	  							red   = (int)((pixelColor >> 16) & 0xff); 
	  							green = (int)((pixelColor >> 8 ) & 0xff);
   								blue  = (int)((pixelColor      ) & 0xff); 
	  							//System.out.println("red:= "+red);
	  							sumNeighborMin = sumNeighborMin-red-green-blue;
	  						} else {
	  							sumNeighborMin = sumNeighborMin+255;
	  						}
	  					}
	  				}
	   				for (int k=i; k<i+controlSurface; k++){
	  					for (int l=j-(int)(0.5*controlSurface); l<j; l++){
	  						if ((k<320)&&(l<240)&&(k>0)&&(l>0)){
	  							pixelColor = buffImgSource.getRGB(k, l);
	  							red   = (int)((pixelColor >> 16) & 0xff); 
	  							green = (int)((pixelColor >> 8 ) & 0xff);
   								blue  = (int)((pixelColor      ) & 0xff); 
	  							//System.out.println("red:= "+red);
	  							sumNeighborMin = sumNeighborMin-red-green-blue;
	  						} else {
	  							sumNeighborMin = sumNeighborMin+255;
	  						}
	  					}
	  				}
	   				for (int k=i; k<i+controlSurface; k++){
	  					for (int l=j+controlSurface; l<j+1.5*controlSurface; l++){
	  						if ((k<320)&&(l<240)&&(k>0)&&(l>0)){
	  							pixelColor = buffImgSource.getRGB(k, l);
	  							red   = (int)((pixelColor >> 16) & 0xff); 
	  							green = (int)((pixelColor >> 8 ) & 0xff);
   								blue  = (int)((pixelColor      ) & 0xff); 
	  							//System.out.println("red:= "+red);
	  							sumNeighborMin = sumNeighborMin-red-green-blue;
	  						} else {
	  							sumNeighborMin = sumNeighborMin+255;
	  						}
	  					}
	  				}
	  				
	  				////////////////////////////////////////////////////////////////7
	  				//if (sumNeighbor>controlSurface*controlSurface*250){
					if (((sumNeighborMax*20-sumNeighborMin)>maxSumNeighbor)&&(sumNeighborMax>0)){
	  					maxSumNeighbor = sumNeighborMax*20-sumNeighborMin;
		  				//System.out.println("sumNeighborMax("+i+","+j+") := "+sumNeighborMax);
		  				//System.out.println("sumNeighborMin("+i+","+j+") := "+sumNeighborMin);
	  					//System.out.println("pos robot =  "+i+";"+j+" sumNeighborMax-sumNeighborMin:= "+(sumNeighborMax-sumNeighborMin));
	  					posRobot[0]= i;
	  					posRobot[1]= j;
	  				}
	  			}
	  		}
			}
		}
		return posRobot;
	}
	
	
/* OPERATOR FOUNDROBOT	V.2
 * ---------------------------------------------------------------------------
 * methode similaire a la precedante mais avec certaine ponderation qui on 
 * change.
 */
	public static int[] foundRobotV2(BufferedImage buffImgSource, int robotMinSize, int bord){
    int w = buffImgSource.getWidth(null);
    int h = buffImgSource.getHeight(null);
    BufferedImage buffImgDest = new BufferedImage(w, h, BufferedImage.TYPE_INT_ARGB);
    int depX;
    int stopX;
    int sumNeighborMax;
    int sumNeighborMin;
    int[] posRobot = new int[2];
    int controlSurface = robotMinSize;
    int maxSumNeighbor = 0;
    
   	depX = 0+bord;
    stopX = 320-bord;

    System.out.println("analyse du robot jaune :===============================");
    for (int i=depX ; i<stopX; i++) {
      for (int j = 0+bord; j < h-bord; j++) {
        int pixelColor = buffImgSource.getRGB(i, j);
       	int red   = (int)((pixelColor >> 16) & 0xff); 
       	int green = (int)((pixelColor >> 8 ) & 0xff);
   			int blue  = (int)((pixelColor      ) & 0xff); 
	  		if ((red==0xff) && (green ==0xff) && (blue == 0)){
	  			sumNeighborMax = 0;
	  			sumNeighborMin = 0;
	  			if ((i<320-(controlSurface+1))&&(j<240-(controlSurface+1))){
	  				// controle des voisin
	  				//System.out.println("pos "+i+";"+j);
	  				for (int k=i; k<i+controlSurface; k++){
	  					for (int l=j; l<j+controlSurface; l++){
	  						pixelColor = buffImgSource.getRGB(k, l);
	  						red   = (int)((pixelColor >> 16) & 0xff); 
	  						green = (int)((pixelColor >> 8 ) & 0xff);
   							blue  = (int)((pixelColor      ) & 0xff); 
	  						//System.out.println("red:= "+red);
	  						sumNeighborMax = sumNeighborMax+(red+green-1*blue);
	  					}
	  				}
	  				/////////////////////////////////////////////////////////////////
	  				
	  				for (int k=i+controlSurface; k<i+1.5*controlSurface; k++){
	  					for (int l=j-(int)(0.5*controlSurface); l<j+1.5*controlSurface; l++){
	  						if ((k<320)&&(l<240)&&(k>0)&&(l>0)){
	  							pixelColor = buffImgSource.getRGB(k, l);
	  							red   = (int)((pixelColor >> 16) & 0xff); 
	  							green = (int)((pixelColor >> 8 ) & 0xff);
   								blue  = (int)((pixelColor      ) & 0xff); 
	  							//System.out.println("red:= "+red);
	  							sumNeighborMin = sumNeighborMin-red-green-blue;
	  						} else {
	  							sumNeighborMin = sumNeighborMin+255;
	  						}
	  					}
	  				}
	  				
	   				for (int k=i-(int)(0.5*controlSurface); k<i; k++){
	  					for (int l=j-(int)(0.5*controlSurface); l<j+1.5*controlSurface; l++){
	  						if ((k<320)&&(l<240)&&(k>0)&&(l>0)){
	  							pixelColor = buffImgSource.getRGB(k, l);
	  							red   = (int)((pixelColor >> 16) & 0xff); 
	  							green = (int)((pixelColor >> 8 ) & 0xff);
   								blue  = (int)((pixelColor      ) & 0xff); 
	  							//System.out.println("red:= "+red);
	  							sumNeighborMin = sumNeighborMin-red-green-blue;
	  						} else {
	  							sumNeighborMin = sumNeighborMin+255;
	  						}
	  					}
	  				}
	   				for (int k=i; k<i+controlSurface; k++){
	  					for (int l=j-(int)(0.5*controlSurface); l<j; l++){
	  						if ((k<320)&&(l<240)&&(k>0)&&(l>0)){
	  							pixelColor = buffImgSource.getRGB(k, l);
	  							red   = (int)((pixelColor >> 16) & 0xff); 
	  							green = (int)((pixelColor >> 8 ) & 0xff);
   								blue  = (int)((pixelColor      ) & 0xff); 
	  							//System.out.println("red:= "+red);
	  							sumNeighborMin = sumNeighborMin-red-green-blue;
	  						} else {
	  							sumNeighborMin = sumNeighborMin+255;
	  						}
	  					}
	  				}
	   				for (int k=i; k<i+controlSurface; k++){
	  					for (int l=j+controlSurface; l<j+1.5*controlSurface; l++){
	  						if ((k<320)&&(l<240)&&(k>0)&&(l>0)){
	  							pixelColor = buffImgSource.getRGB(k, l);
	  							red   = (int)((pixelColor >> 16) & 0xff); 
	  							green = (int)((pixelColor >> 8 ) & 0xff);
   								blue  = (int)((pixelColor      ) & 0xff); 
	  							//System.out.println("red:= "+red);
	  							sumNeighborMin = sumNeighborMin-red-green-blue;
	  						} else {
	  							sumNeighborMin = sumNeighborMin+255;
	  						}
	  					}
	  				}
	  				
	  				////////////////////////////////////////////////////////////////7
	  				//if (sumNeighbor>controlSurface*controlSurface*250){
					if (((sumNeighborMax*20-sumNeighborMin)>maxSumNeighbor)&&(sumNeighborMax>0)){
	  					maxSumNeighbor = sumNeighborMax*20-sumNeighborMin;
		  				//System.out.println("sumNeighborMax("+i+","+j+") := "+sumNeighborMax);
		  				//System.out.println("sumNeighborMin("+i+","+j+") := "+sumNeighborMin);
	  					//System.out.println("pos robot =  "+i+";"+j+" sumNeighborMax-sumNeighborMin:= "+(sumNeighborMax-sumNeighborMin));
	  					posRobot[0]= i;
	  					posRobot[1]= j;
	  				}
	  			}
	  		}
			}
		}
		return posRobot;
	}
	
	
/* OPERATEUR FOUND RED CYLINDER
 * ------------------------------------------------------------------------
 * toutes les methode qui suivent sont quasiment les meme a queleque 
 * ponderation pres, pour tout les cylindre.
 * La methode de recherche est la meme que la recherche du robot, on va 
 * rechercher une surface rouge, verte ou bleu de taille recherchee, avec
 * condition que les pixels voisin soient blanc.
 */
	
	public static int[] foundRedCylinder(BufferedImage buffImgSource, int borneX, int redCylSurf, int bord, boolean gauche){
    int w = buffImgSource.getWidth(null);
    int h = buffImgSource.getHeight(null);
    BufferedImage buffImgDest = new BufferedImage(w, h, BufferedImage.TYPE_INT_ARGB);
    int depX;
    int stopX;
    int sumNeighborMax;
    int sumNeighborMin;
    int[] posRedCylinder = new int[2];
    int controlSurface = redCylSurf;
    int maxSumNeighbor = 0;
    
    if (gauche){ 
    	depX = 0;
    	stopX = borneX;
    } else {
    	depX = borneX;
    	stopX = 320-controlSurface;
    }
    System.out.println("analyse du red cylinder :===============================");
    System.out.println("debut de la recheche a la pos x:= "+depX+" stop a "+stopX);
    for (int i=depX ; i<stopX; i++) {
      for (int j = 0; j < h; j++) {
      	//System.out.println("get pixels("+i+","+j+")");
        int pixelColor = buffImgSource.getRGB(i, j);
       	int red   = (int)((pixelColor >> 16) & 0xff); 
       	int green = (int)((pixelColor >> 8 ) & 0xff);
   		int blue  = (int)((pixelColor      ) & 0xff); 
   		//System.out.println("analyse "+i+","+j+") couleurs := "+red+","+green+","+blue);
	  		if ((red==0xff) && (green ==0) && (blue == 0)){
	  			sumNeighborMax = 0;
	  			sumNeighborMin = 0;
	  			//System.out.println("analyse "+i+","+j+")");
	  			if ((i<320-(controlSurface+1))&&(j<240-(controlSurface+1))&&(j>0)&&(i>0)){
	  				// controle des voisin
	  				//System.out.println("pos "+i+";"+j);
	  				for (int k=i; k<i+controlSurface; k++){
	  					for (int l=j; l<j+controlSurface; l++){
	  						pixelColor = buffImgSource.getRGB(k, l);
	  						red   = (int)((pixelColor >> 16) & 0xff); 
	  						green = (int)((pixelColor >> 8 ) & 0xff);
   							blue  = (int)((pixelColor      ) & 0xff); 
	  						//System.out.println("red:= "+red);
	  						sumNeighborMax = sumNeighborMax+red-green-blue;
	  						//System.out.println("sumNeighborMax("+k+","+l+") := "+sumNeighborMax);
	  					}
	  				}
	   				for (int k=i+controlSurface; k<i+1.5*controlSurface; k++){
	  					for (int l=j-(int)(0.5*controlSurface); l<j+1.5*controlSurface; l++){
	  						if ((k<320)&&(l<240)&&(k>0)&&(l>0)){
	  							pixelColor = buffImgSource.getRGB(k, l);
	  							red   = (int)((pixelColor >> 16) & 0xff); 
	  							green = (int)((pixelColor >> 8 ) & 0xff);
   								blue  = (int)((pixelColor      ) & 0xff); 
	  							//System.out.println("red:= "+red);
	  							sumNeighborMin = sumNeighborMin+red-green-blue;
	  						} else {
	  							sumNeighborMin = sumNeighborMin+255;
	  						}
	  					}
	  				}
	  				
	   				for (int k=i-(int)(0.5*controlSurface); k<i; k++){
	  					for (int l=j-(int)(0.5*controlSurface); l<j+1.5*controlSurface; l++){
	  						if ((k<320)&&(l<240)&&(k>0)&&(l>0)){
	  							pixelColor = buffImgSource.getRGB(k, l);
	  							red   = (int)((pixelColor >> 16) & 0xff); 
	  							green = (int)((pixelColor >> 8 ) & 0xff);
   								blue  = (int)((pixelColor      ) & 0xff); 
	  							//System.out.println("red:= "+red);
	  							sumNeighborMin = sumNeighborMin+red-green-blue;
	  						} else {
	  							sumNeighborMin = sumNeighborMin+255;
	  						}
	  					}
	  				}
	   				for (int k=i; k<i+controlSurface; k++){
	  					for (int l=j-(int)(0.5*controlSurface); l<j; l++){
	  						if ((k<320)&&(l<240)&&(k>0)&&(l>0)){
	  							pixelColor = buffImgSource.getRGB(k, l);
	  							red   = (int)((pixelColor >> 16) & 0xff); 
	  							green = (int)((pixelColor >> 8 ) & 0xff);
   								blue  = (int)((pixelColor      ) & 0xff); 
	  							//System.out.println("red:= "+red);
	  							sumNeighborMin = sumNeighborMin+red-green-blue;
	  						} else {
	  							sumNeighborMin = sumNeighborMin+255;
	  						}
	  					}
	  				}
	   				for (int k=i; k<i+controlSurface; k++){
	  					for (int l=j+controlSurface; l<j+1.5*controlSurface; l++){
	  						if ((k<320)&&(l<240)&&(k>0)&&(l>0)){
	  							pixelColor = buffImgSource.getRGB(k, l);
	  							red   = (int)((pixelColor >> 16) & 0xff); 
	  							green = (int)((pixelColor >> 8 ) & 0xff);
   								blue  = (int)((pixelColor      ) & 0xff); 
	  							//System.out.println("red:= "+red);
	  							sumNeighborMin = sumNeighborMin+red-green-blue;
	  						} else {
	  							sumNeighborMin = sumNeighborMin+255;
	  						}
	  					}
	  				}
	  				
	  				//System.out.println("sumNeighborMax("+i+","+j+") := "+sumNeighborMax);
	  				//if (sumNeighbor>controlSurface*controlSurface*250){
	  				if (((sumNeighborMax-sumNeighborMin)>maxSumNeighbor)&&(sumNeighborMax>0)){
	  					maxSumNeighbor = sumNeighborMax-sumNeighborMin;
	  					System.out.println("cylindre rouge pos "+i+";"+j+" sumNeighborMax:= "+sumNeighborMax+" sumNeighborMin := "+sumNeighborMin);
	  					posRedCylinder[0]= i;
	  					posRedCylinder[1]= j;
	  				}
	  			}
	  		}
			}
		}
		return posRedCylinder;
	}
	
	
	
// OPERATEUR FOUND BLUE CYLINDER
// ------------------------------------------------------------------------

public static int[] foundBlueCylinder(BufferedImage buffImgSource, int borneX, int blueCylSurf, int bord, boolean gauche){
    int w = buffImgSource.getWidth(null);
    int h = buffImgSource.getHeight(null);
    BufferedImage buffImgDest = new BufferedImage(w, h, BufferedImage.TYPE_INT_ARGB);
    int depX;
    int stopX;
    int sumNeighborMax;
    int sumNeighborMin;
    int[] posBlueCylinder = new int[2];
    int controlSurface = blueCylSurf;
    int maxSumNeighbor = 0;   
    
    if (gauche){ 
    	depX = 0+bord;
    	stopX = borneX;
    } else {
    	depX = borneX;
    	stopX = 320-bord;
    }
    System.out.println("analyse du blue cylinder :===============================");
    for (int i=depX ; i<stopX; i++) {
      for (int j = bord; j < h-bord; j++) {
        int pixelColor = buffImgSource.getRGB(i, j);
       	int red   = (int)((pixelColor >> 16) & 0xff); 
       	int green = (int)((pixelColor >> 8 ) & 0xff);
   			int blue  = (int)((pixelColor      ) & 0xff); 
	  		if ((red==0) && (green ==0) && (blue == 0xff)){
	  			sumNeighborMax = 0;
	  			sumNeighborMin = 0;
	  			if ((i<320-(controlSurface+1))&&(j<240-(controlSurface+1))){
	  				// controle des voisin
	  				//System.out.println("pos "+i+";"+j);
	  				for (int k=i; k<i+controlSurface; k++){
	  					for (int l=j; l<j+controlSurface; l++){
	  						pixelColor = buffImgSource.getRGB(k, l);
	  						red   = (int)((pixelColor >> 16) & 0xff); 
	  						green = (int)((pixelColor >> 8 ) & 0xff);
   							blue  = (int)((pixelColor      ) & 0xff); 
	  						//System.out.println("red:= "+red);
	  						sumNeighborMax = sumNeighborMax+blue-red-green;
	  					}
	  				}
	  				for (int k=i+controlSurface; k<i+1.5*controlSurface; k++){
	  					for (int l=j-(int)(0.5*controlSurface); l<j+1.5*controlSurface; l++){
	  						if ((k<320)&&(l<240)&&(k>0)&&(l>0)){
	  							pixelColor = buffImgSource.getRGB(k, l);
	  							red   = (int)((pixelColor >> 16) & 0xff); 
	  							green = (int)((pixelColor >> 8 ) & 0xff);
   								blue  = (int)((pixelColor      ) & 0xff); 
		  						//System.out.println("red:= "+red);
		  						sumNeighborMin = sumNeighborMin+blue-red-green;
		  					} else {
	  							sumNeighborMin = sumNeighborMin+255;
	  						}
	  					}
	  				}
	  				
	   				for (int k=i-(int)(0.5*controlSurface); k<i; k++){
	  					for (int l=j-(int)(0.5*controlSurface); l<j+1.5*controlSurface; l++){
	  						if ((k<320)&&(l<240)&&(k>0)&&(l>0)){
	  							pixelColor = buffImgSource.getRGB(k, l);
	  							red   = (int)((pixelColor >> 16) & 0xff); 
	  							green = (int)((pixelColor >> 8 ) & 0xff);
   								blue  = (int)((pixelColor      ) & 0xff); 
	  							//System.out.println("red:= "+red);
	  							sumNeighborMin = sumNeighborMin+blue-red-green;
	  						} else {
	  							sumNeighborMin = sumNeighborMin+255;
	  						}
	  					}
	  				}
	   				for (int k=i; k<i+controlSurface; k++){
	  					for (int l=j-(int)(0.5*controlSurface); l<j; l++){
	  						if ((k<320)&&(l<240)&&(k>0)&&(l>0)){
	  							pixelColor = buffImgSource.getRGB(k, l);
	  							red   = (int)((pixelColor >> 16) & 0xff); 
	  							green = (int)((pixelColor >> 8 ) & 0xff);
   								blue  = (int)((pixelColor      ) & 0xff); 
	  							//System.out.println("red:= "+red);
	  							sumNeighborMin = sumNeighborMin+blue-red-green;
	  						} else {
	  							sumNeighborMin = sumNeighborMin+255;
	  						}
	  					}
	  				}
	   				for (int k=i; k<i+controlSurface; k++){
	  					for (int l=j+controlSurface; l<j+1.5*controlSurface; l++){
	  						if ((k<320)&&(l<240)&&(k>0)&&(l>0)){
	  							pixelColor = buffImgSource.getRGB(k, l);
	  							red   = (int)((pixelColor >> 16) & 0xff); 
	  							green = (int)((pixelColor >> 8 ) & 0xff);
   								blue  = (int)((pixelColor      ) & 0xff); 
	  							//System.out.println("red:= "+red);
	  							sumNeighborMin = sumNeighborMin+blue-red-green;
	  						} else {
	  							sumNeighborMin = sumNeighborMin+255;
	  						}
	  					}
	  				}
	  				
	  				//if (sumNeighbor>controlSurface*controlSurface*250){
	  				if (sumNeighborMax-sumNeighborMin>maxSumNeighbor){
	  					maxSumNeighbor = sumNeighborMax-sumNeighborMin;
	  					System.out.println("cylindre bleu pos "+i+";"+j+" sumNeighborMax:= "+sumNeighborMax+" sumNeighborMin := "+sumNeighborMin);
	  					posBlueCylinder[0]= i;
	  					posBlueCylinder[1]= j;
	  				}
	  			}
	  		}
			}
		}
		return posBlueCylinder;
	}

	
// OPERATEUR FOUND BLUE CYLINDER FROM BLUE COMPOSANT IMAGE
// ------------------------------------------------------------------------
	public static int[] foundBlueCylinderFromBlue(BufferedImage buffImgSource, int borneX, int blueCylSurf, int bord, boolean gauche){
    int w = buffImgSource.getWidth(null);
    int h = buffImgSource.getHeight(null);
    BufferedImage buffImgDest = new BufferedImage(w, h, BufferedImage.TYPE_INT_ARGB);
    int depX;
    int stopX;
    int sumNeighborMax;
    int sumNeighborMin;
    int[] posBlueCylinder = new int[2];
    int controlSurface = blueCylSurf;
    int maxSumNeighbor = 0;   
    
    if (gauche){ 
    	depX = 0+bord;
    	stopX = borneX;
    } else {
    	depX = borneX;
    	stopX = 320-bord;
    }
    System.out.println("analyse du blue cylinder :===============================");
    for (int i=depX ; i<stopX; i++) {
      for (int j = bord; j < h-bord; j++) {
        int pixelColor = buffImgSource.getRGB(i, j);
       	int red   = (int)((pixelColor >> 16) & 0xff); 
       	int green = (int)((pixelColor >> 8 ) & 0xff);
   			int blue  = (int)((pixelColor      ) & 0xff); 
	  		if ((red==0) && (green ==0) && (blue == 0xff)){
	  			sumNeighborMax = 0;
	  			sumNeighborMin = 0;
	  			if ((i<320-(controlSurface+1))&&(j<240-(controlSurface+1))){
	  				// controle des voisin
	  				//System.out.println("pos "+i+";"+j);
	  				for (int k=i; k<i+controlSurface; k++){
	  					for (int l=j; l<j+controlSurface; l++){
	  						pixelColor = buffImgSource.getRGB(k, l);
	  						red   = (int)((pixelColor >> 16) & 0xff); 
	  						green = (int)((pixelColor >> 8 ) & 0xff);
   							blue  = (int)((pixelColor      ) & 0xff); 
	  						//System.out.println("red:= "+red);
	  						sumNeighborMax = sumNeighborMax+(10*blue)-red-green;
	  					}
	  				}/*
	  				for (int k=i+controlSurface; k<i+1.5*controlSurface; k++){
	  					for (int l=j-(int)(0.5*controlSurface); l<j+1.5*controlSurface; l++){
	  						if ((k<320)&&(l<240)&&(k>0)&&(l>0)){
	  							pixelColor = buffImgSource.getRGB(k, l);
	  							red   = (int)((pixelColor >> 16) & 0xff); 
	  							green = (int)((pixelColor >> 8 ) & 0xff);
   								blue  = (int)((pixelColor      ) & 0xff); 
		  						//System.out.println("red:= "+red);
		  						sumNeighborMin = sumNeighborMin+blue-(255-red)-(255-green);
		  					} else {
	  							sumNeighborMin = sumNeighborMin+255;
	  						}
	  					}
	  				}
	  				
	   				for (int k=i-(int)(0.5*controlSurface); k<i; k++){
	  					for (int l=j-(int)(0.5*controlSurface); l<j+1.5*controlSurface; l++){
	  						if ((k<320)&&(l<240)&&(k>0)&&(l>0)){
	  							pixelColor = buffImgSource.getRGB(k, l);
	  							red   = (int)((pixelColor >> 16) & 0xff); 
	  							green = (int)((pixelColor >> 8 ) & 0xff);
   								blue  = (int)((pixelColor      ) & 0xff); 
	  							//System.out.println("red:= "+red);
	  							sumNeighborMin = sumNeighborMin+blue-(255-red)-(255-green);
	  						} else {
	  							sumNeighborMin = sumNeighborMin+255;
	  						}
	  					}
	  				}
	   				for (int k=i; k<i+controlSurface; k++){
	  					for (int l=j-(int)(0.5*controlSurface); l<j; l++){
	  						if ((k<320)&&(l<240)&&(k>0)&&(l>0)){
	  							pixelColor = buffImgSource.getRGB(k, l);
	  							red   = (int)((pixelColor >> 16) & 0xff); 
	  							green = (int)((pixelColor >> 8 ) & 0xff);
   								blue  = (int)((pixelColor      ) & 0xff); 
	  							//System.out.println("red:= "+red);
	  							sumNeighborMin = sumNeighborMin+blue-(255-red)-(255-green);
	  						} else {
	  							sumNeighborMin = sumNeighborMin+255;
	  						}
	  					}
	  				}
	   				for (int k=i; k<i+controlSurface; k++){
	  					for (int l=j+controlSurface; l<j+1.5*controlSurface; l++){
	  						if ((k<320)&&(l<240)&&(k>0)&&(l>0)){
	  							pixelColor = buffImgSource.getRGB(k, l);
	  							red   = (int)((pixelColor >> 16) & 0xff); 
	  							green = (int)((pixelColor >> 8 ) & 0xff);
   								blue  = (int)((pixelColor      ) & 0xff); 
	  							//System.out.println("red:= "+red);
	  							sumNeighborMin = sumNeighborMin+blue-(255-red)-(255-green);
	  						} else {
	  							sumNeighborMin = sumNeighborMin+255;
	  						}
	  					}
	  				}
	  				*/
	  				//if (sumNeighbor>controlSurface*controlSurface*250){
	  				//System.out.println("sumNeighborMax := "+ sumNeighborMax);
	  				if (sumNeighborMax-sumNeighborMin>maxSumNeighbor){
	  					maxSumNeighbor = sumNeighborMax-sumNeighborMin;
	  					System.out.println("cylindre bleu pos "+i+";"+j+" sumNeighborMax:= "+sumNeighborMax+" sumNeighborMin := "+sumNeighborMin);
	  					posBlueCylinder[0]= i;
	  					posBlueCylinder[1]= j;
	  				}
	  			}
	  		}
			}
		}
		return posBlueCylinder;
	}	
	
	
// OPERATEUR FOUND GREEN CYLINDER
// ------------------------------------------------------------------------
	public static int[] foundGreenCylinder(BufferedImage buffImgSource, int borneX, int greenCylSurf, int bord, boolean gauche){
    int w = buffImgSource.getWidth(null);
    int h = buffImgSource.getHeight(null);
    BufferedImage buffImgDest = new BufferedImage(w, h, BufferedImage.TYPE_INT_ARGB);
    int depX;
    int stopX;
    int sumNeighborMax;
    int sumNeighborMin;
    int[] posGreenCylinder = new int[2];
    int controlSurface = greenCylSurf;
    int maxSumNeighbor = 0; 
    
    if (gauche){ 
    	depX = 0+bord;
    	stopX = borneX;
    } else {
    	depX = borneX;
    	stopX = 320-bord;
    }
    System.out.println("analyse du green cylinder :===============================");
    for (int i=depX ; i<stopX; i++) {
      for (int j = bord; j < h-bord; j++) {
        int pixelColor = buffImgSource.getRGB(i, j);
       	int red   = (int)((pixelColor >> 16) & 0xff); 
       	int green = (int)((pixelColor >> 8 ) & 0xff);
   			int blue  = (int)((pixelColor      ) & 0xff); 
	  		if ((red==0) && (green ==255) && (blue == 0)){
	  			sumNeighborMax = 0;
	  			sumNeighborMin = 0;
	  			if ((i<320-(controlSurface+1))&&(j<240-(controlSurface+1))){
	  				// controle des voisin
	  				//System.out.println("pos "+i+";"+j);
	  				for (int k=i; k<i+controlSurface; k++){
	  					for (int l=j; l<j+controlSurface; l++){
	  						pixelColor = buffImgSource.getRGB(k, l);
	  						red   = (int)((pixelColor >> 16) & 0xff); 
	  						green = (int)((pixelColor >> 8 ) & 0xff);
   							blue  = (int)((pixelColor      ) & 0xff); 
	  						//System.out.println("red:= "+red);
	  						sumNeighborMax = sumNeighborMax+green-blue-red;
	  					}
	  				}
	  			
	  				for (int k=i+controlSurface; k<i+1.5*controlSurface; k++){
	  					for (int l=j-(int)(0.5*controlSurface); l<j+1.5*controlSurface; l++){
	  						if ((k<320)&&(l<240)&&(k>0)&&(l>0)){
	  							pixelColor = buffImgSource.getRGB(k, l);
	  							red   = (int)((pixelColor >> 16) & 0xff); 
	  							green = (int)((pixelColor >> 8 ) & 0xff);
   								blue  = (int)((pixelColor      ) & 0xff); 
	  							//System.out.println("red:= "+red);
	  							sumNeighborMin = sumNeighborMin+green-blue-red;
	  						} else {
	  							sumNeighborMin = sumNeighborMin+255;
	  						}
	  					}
	  				}
	  				
	   				for (int k=i-(int)(0.5*controlSurface); k<i; k++){
	  					for (int l=j-(int)(0.5*controlSurface); l<j+1.5*controlSurface; l++){
	  						if ((k<320)&&(l<240)&&(k>0)&&(l>0)){
	  							pixelColor = buffImgSource.getRGB(k, l);
	  							red   = (int)((pixelColor >> 16) & 0xff); 
	  							green = (int)((pixelColor >> 8 ) & 0xff);
   								blue  = (int)((pixelColor      ) & 0xff); 
	  							//System.out.println("red:= "+red);
	  							sumNeighborMin = sumNeighborMin+green-blue-red;
	  						} else {
	  							sumNeighborMin = sumNeighborMin+255;
	  						}
	  					}
	  				}
	   				for (int k=i; k<i+controlSurface; k++){
	  					for (int l=j-(int)(0.5*controlSurface); l<j; l++){
	  						if ((k<320)&&(l<240)&&(k>0)&&(l>0)){
	  							pixelColor = buffImgSource.getRGB(k, l);
	  							red   = (int)((pixelColor >> 16) & 0xff); 
	  							green = (int)((pixelColor >> 8 ) & 0xff);
   								blue  = (int)((pixelColor      ) & 0xff); 
	  							//System.out.println("red:= "+red);
	  							sumNeighborMin = sumNeighborMin+green-blue-red;
	  						} else {
	  							sumNeighborMin = sumNeighborMin+255;
	  						}
	  					}
	  				}
	   				for (int k=i; k<i+controlSurface; k++){
	  					for (int l=j+controlSurface; l<j+1.5*controlSurface; l++){
	  						if ((k<320)&&(l<240)&&(k>0)&&(l>0)){
	  							pixelColor = buffImgSource.getRGB(k, l);
	  							red   = (int)((pixelColor >> 16) & 0xff); 
	  							green = (int)((pixelColor >> 8 ) & 0xff);
   								blue  = (int)((pixelColor      ) & 0xff); 
	  							//System.out.println("red:= "+red);
	  							sumNeighborMin = sumNeighborMin+green-blue-red;
	  						} else {
	  							sumNeighborMin = sumNeighborMin+255;
	  						}
	  					}
	  				}
	  				
	  				//if (sumNeighbor>controlSurface*controlSurface*250){
	  				if (sumNeighborMax-sumNeighborMin>maxSumNeighbor){
	  					maxSumNeighbor = sumNeighborMax-sumNeighborMin;
	  					System.out.println("cylindre vert  pos "+i+";"+j+" sumNeighborMax:= "+sumNeighborMax+" sumNeighborMin := "+sumNeighborMin);
	  					posGreenCylinder[0]= i;
	  					posGreenCylinder[1]= j;
	  					if (sumNeighborMax < -20000){
	  						posGreenCylinder[0]= 0;
	  						posGreenCylinder[1]= 0;
	  					}
	  				}
	  			}
	  		}
			}
		}
		return posGreenCylinder;
	}


// OPERATEUR FOUND GREEN CYLINDER FROM GREEN
// ------------------------------------------------------------------------
	public static int[] foundGreenCylinderFromGreen(BufferedImage buffImgSource, int borneX, int greenCylSurf, int bord, boolean gauche,int[] posBlueCylinder){
    int w = buffImgSource.getWidth(null);
    int h = buffImgSource.getHeight(null);
    BufferedImage buffImgDest = new BufferedImage(w, h, BufferedImage.TYPE_INT_ARGB);
    int depX;
    int stopX;
    int sumNeighborMax;
    int sumNeighborMin;
    int[] posGreenCylinder = new int[2];
    int controlSurface = greenCylSurf;
    int maxSumNeighbor = 0; 
    
    if (gauche){ 
    	depX = 0+bord;
    	stopX = borneX;
    } else {
    	depX = borneX;
    	stopX = 320-bord;
    }
    System.out.println("analyse du green cylinder :===============================");
    for (int i=depX ; i<stopX; i++) {
      for (int j = bord; j < h-bord; j++) {
        int pixelColor = buffImgSource.getRGB(i, j);
       	int red   = (int)((pixelColor >> 16) & 0xff); 
       	int green = (int)((pixelColor >> 8 ) & 0xff);
   			int blue  = (int)((pixelColor      ) & 0xff); 
	  		if ((red==0) && (green ==255) && (blue == 0)){
	  			sumNeighborMax = 0;
	  			sumNeighborMin = 0;
	  			if ((i<320-(controlSurface+1))&&(j<240-(controlSurface+1))){
	  				// controle des voisin
	  				//System.out.println("pos "+i+";"+j);
	  				for (int k=i; k<i+controlSurface; k++){
	  					for (int l=j; l<j+controlSurface; l++){
	  						pixelColor = buffImgSource.getRGB(k, l);
	  						red   = (int)((pixelColor >> 16) & 0xff); 
	  						green = (int)((pixelColor >> 8 ) & 0xff);
   							blue  = (int)((pixelColor      ) & 0xff); 
	  						//System.out.println("red:= "+red);
	  						sumNeighborMax = sumNeighborMax+(10*green)-blue-red;
	  					}
	  				}
	  				/*
	  				for (int k=i+controlSurface; k<i+1.5*controlSurface; k++){
	  					for (int l=j-(int)(0.5*controlSurface); l<j+1.5*controlSurface; l++){
	  						if ((k<320)&&(l<240)&&(k>0)&&(l>0)){
	  							pixelColor = buffImgSource.getRGB(k, l);
	  							red   = (int)((pixelColor >> 16) & 0xff); 
	  							green = (int)((pixelColor >> 8 ) & 0xff);
   								blue  = (int)((pixelColor      ) & 0xff); 
	  							//System.out.println("red:= "+red);
	  							sumNeighborMin = sumNeighborMin+green-blue-red;
	  						} else {
	  							sumNeighborMin = sumNeighborMin+255;
	  						}
	  					}
	  				}
	  				
	   				for (int k=i-(int)(0.5*controlSurface); k<i; k++){
	  					for (int l=j-(int)(0.5*controlSurface); l<j+1.5*controlSurface; l++){
	  						if ((k<320)&&(l<240)&&(k>0)&&(l>0)){
	  							pixelColor = buffImgSource.getRGB(k, l);
	  							red   = (int)((pixelColor >> 16) & 0xff); 
	  							green = (int)((pixelColor >> 8 ) & 0xff);
   								blue  = (int)((pixelColor      ) & 0xff); 
	  							//System.out.println("red:= "+red);
	  							sumNeighborMin = sumNeighborMin+green-blue-red;
	  						} else {
	  							sumNeighborMin = sumNeighborMin+255;
	  						}
	  					}
	  				}
	   				for (int k=i; k<i+controlSurface; k++){
	  					for (int l=j-(int)(0.5*controlSurface); l<j; l++){
	  						if ((k<320)&&(l<240)&&(k>0)&&(l>0)){
	  							pixelColor = buffImgSource.getRGB(k, l);
	  							red   = (int)((pixelColor >> 16) & 0xff); 
	  							green = (int)((pixelColor >> 8 ) & 0xff);
   								blue  = (int)((pixelColor      ) & 0xff); 
	  							//System.out.println("red:= "+red);
	  							sumNeighborMin = sumNeighborMin+green-blue-red;
	  						} else {
	  							sumNeighborMin = sumNeighborMin+255;
	  						}
	  					}
	  				}
	   				for (int k=i; k<i+controlSurface; k++){
	  					for (int l=j+controlSurface; l<j+1.5*controlSurface; l++){
	  						if ((k<320)&&(l<240)&&(k>0)&&(l>0)){
	  							pixelColor = buffImgSource.getRGB(k, l);
	  							red   = (int)((pixelColor >> 16) & 0xff); 
	  							green = (int)((pixelColor >> 8 ) & 0xff);
   								blue  = (int)((pixelColor      ) & 0xff); 
	  							//System.out.println("red:= "+red);
	  							sumNeighborMin = sumNeighborMin+green-blue-red;
	  						} else {
	  							sumNeighborMin = sumNeighborMin+255;
	  						}
	  					}
	  				}
	  				*/
	  				//if (sumNeighbor>controlSurface*controlSurface*250){
	  				if ((i<posBlueCylinder[0]+5) && (i>posBlueCylinder[1]+5) && (i<posBlueCylinder[1]+5)&&(i<posBlueCylinder[1]-5)){
	  					sumNeighborMax = 0;
	  				}
	  					
	  				//System.out.println("sumNeighborMax := "+ sumNeighborMax);
	  				if (sumNeighborMax-sumNeighborMin>maxSumNeighbor){
	  					maxSumNeighbor = sumNeighborMax-sumNeighborMin;
	  					System.out.println("cylindre vert  pos "+i+";"+j+" sumNeighborMax:= "+sumNeighborMax+" sumNeighborMin := "+sumNeighborMin);
	  					posGreenCylinder[0]= i;
	  					posGreenCylinder[1]= j;
	  					if (sumNeighborMax < -20000){
	  						posGreenCylinder[0]= 0;
	  						posGreenCylinder[1]= 0;
	  					}
	  				}
	  			}
	  		}
			}
		}
		return posGreenCylinder;
	}
}

