/* EHRLER FREDERIC - MICHEL DERIAZ
 * ------------------------------------------------------------------
 * cette classe va contenir toutes les informations relative au terrain
 * c'est a dire la position des murs des portes, des cylindre et du
 * robot.
 * de plus les methode les methode qui retrourne les donnees les rend
 * dans le format accepte par les simulateur, c'est a dire des position
 * reel et non en pixel. 
 *
 */

import java.awt.Point;

public class Terrain{
	final int decalageX = 0;
	final int decalageY = 0;
	final int dimTerrainX = 1188;
	final int dimTerrainY = 840;
	final int[] redGoal = new int[2];
	final int[] greenGoal = new int[2];
	final int[] blueGoal = new int[2];
	int[] wallPos;
	int[] redCylPos;
	int[] greenCylPos;
	int[] blueCylPos;
	int[] avantRobot;
	int[][] doors;
	int[][] coinRobot;
	int rayonCylindre = 0;
	double facteurX;
	double facteurY;
	
	public Terrain(){
		//!!!!!! attention peut etre fait une inversion
		facteurX = (double)1188/(double)320;
		facteurY = (double)840/(double)240;
		System.out.println("facteurX := "+facteurX);
		System.out.println("facteurY := "+facteurY);
		
		
		redGoal[0] = 560;
		redGoal[1] = 165;
		greenGoal[0] = 305;
		greenGoal[1] = 255;
		blueGoal[0] = 680;
		blueGoal[1] = 330;
	}

	public void setCylindreDiameter(int diametreCylindre){
		this.rayonCylindre = diametreCylindre/2;
	}

	public void setWallPos(int[] wallPos){
		this.wallPos = wallPos;
	}
	
	public void setRedCylPos(int[] redCylPos){
		this.redCylPos = redCylPos;
	}
	
	public void setGreenCylPos(int[] greenCylPos){
		this.greenCylPos = greenCylPos;
	}
	
	public void setBlueCylPos(int[] blueCylPos){
		this.blueCylPos = blueCylPos;
	}
	
	public void setCoinRobot(int[][] coinRobot){
		this.coinRobot = coinRobot;
	}
	
	public void setTopPoint(int[] avantRobot){
		this.avantRobot = avantRobot;
	}
	
	public void setDoors(int[][] doors){
		this.doors = doors;
	}
	
	public int[] getWallPos(){
		 return wallPos;
	}
	
	
////////////////////////////////////////////7	
	public Point getRedCylPos(){
		System.out.println("redCylPosX := "+redCylPos[0]);
		System.out.println("redCylPosY := "+redCylPos[1]);
		System.out.println("(int)(redCylPos[1]*facteurY) := "+(redCylPos[1]*facteurY));
		
		int redCylPosX = (int)((redCylPos[1]+rayonCylindre)*facteurY)+decalageX;
		int redCylPosY = (int)((redCylPos[0]+rayonCylindre)*facteurX)+decalageY;
		
		if (redCylPos[0]<wallPos[0]+10){
			System.out.println("cylindre rouge non present 1 *************************");
			redCylPosX = -1;
			redCylPosY = -1;
		}
		if ((redCylPos[1]<wallPos[1]+10)&&(redCylPos[1]>wallPos[1]-10)){
			System.out.println("cylindre rouge non present 2 **************************");
			redCylPosX = -1;
			redCylPosY = -1;
		}
		if ((redCylPos[0]==0)&&(redCylPos[1]==0)){
			System.out.println("cylindre rouge non present 3 **************************");
			redCylPosX = -1;
			redCylPosY = -1;
		}
		
		
		System.out.println("redCylPosX := "+redCylPosX);
		System.out.println("redCylPosY := "+redCylPosY);
		
		return (new Point(redCylPosX,redCylPosY));
	}
	
	public Point getGreenCylPos(){
		System.out.println("greenCylPosX := "+greenCylPos[0]);
		System.out.println("greenCylPosY := "+greenCylPos[1]);
		
		int greenCylPosX = (int)((greenCylPos[1]+rayonCylindre)*facteurY)+decalageX;
		int greenCylPosY = (int)((greenCylPos[0]+rayonCylindre)*facteurX)+decalageY;

		if (greenCylPos[0]<wallPos[0]+10){
			System.out.println("cylindre vert non present 1 *************************");
			greenCylPosX = -1;
			greenCylPosY = -1;
		}
		if ((greenCylPos[1]<wallPos[1]+10)&&(greenCylPos[1]>wallPos[1]-10)){
			System.out.println("cylindre vert non present 2 **************************");
			greenCylPosX = -1;
			greenCylPosY = -1;
		}
		if ((greenCylPos[0]==0)&&(greenCylPos[1]==0)){
			System.out.println("cylindre vert non present 3 **************************");
			greenCylPosX = -1;
			greenCylPosY = -1;
		}
		
		
		System.out.println("greenCylPosX := "+greenCylPosX);
		System.out.println("greenCylPosY := "+greenCylPosY);
		return (new Point(greenCylPosX,greenCylPosY));
	}
	
	public Point getBlueCylPos(){
		System.out.println("blueCylPosX := "+blueCylPos[0]);
		System.out.println("blueCylPosY := "+blueCylPos[1]);
		int blueCylPosX = (int)((blueCylPos[1]+rayonCylindre)*facteurY)+decalageX;
		int blueCylPosY = (int)((blueCylPos[0]+rayonCylindre)*facteurX)+decalageY;
		
		if (blueCylPos[0]<wallPos[0]+10){
			System.out.println("cylindre bleu non present 1 *************************");
			blueCylPosX = -1;
			blueCylPosY = -1;
		}
		if ((blueCylPos[1]<wallPos[1]+10)&&(blueCylPos[1]>wallPos[1]-10)){
			System.out.println("cylindre bleu non present 2 **************************");
			blueCylPosX = -1;
			blueCylPosY = -1;
		}
		if ((blueCylPos[0]==0)&&(blueCylPos[1]==0)){
			System.out.println("cylindre bleu non present 3 **************************");
			blueCylPosX = -1;
			blueCylPosY = -1;
		}
		
		
		System.out.println("blueCylPosX := "+blueCylPosX);
		System.out.println("blueCylPosY := "+blueCylPosY);
		return (new Point(blueCylPosX,blueCylPosY));
	}
	
	public int[][] getCoinRobot(){
		return coinRobot;
	}
	
	public Triplet getRcx(){
		int[] robotCenter = getRobotCenter();
		System.out.println("robotPosX := "+robotCenter[0]);
		System.out.println("robotPosY := "+robotCenter[1]);
		int robotPosX = (int)(robotCenter[1]*facteurY)+decalageX;;
		int robotPosY = (int)(robotCenter[0]*facteurX)+decalageY;
		System.out.println("robotPosX := "+robotPosX);
		System.out.println("robotPosY := "+robotPosY);
		System.out.println("angleRobot := "+(int)getRobotAngle());
		
		return (new Triplet(robotPosX,robotPosY,(int)getRobotAngle()));
	}
	
	public Point getHorizontalDoor(){
		int horizDoorX = (int)((((doors[1][1]-doors[1][0])/2)+doors[1][0])*facteurY)+decalageX;
		int horizDoorY = (int)(wallPos[0]*facteurX)+decalageY;
		
		System.out.println("doors[1][1]-doors[1][0])/2+doors[1][0] := "+(((doors[1][1]-doors[1][0])/2)+doors[1][0]));
		System.out.println("wallPos[0] := "+wallPos[0]);
		System.out.println("HorizDoorX := "+horizDoorX);
		System.out.println("HorizDoorY := "+horizDoorY);	

		return (new Point(horizDoorX,horizDoorY));
	}
	
	public Point getVerticalDoor(){
		int vertDoorX = (int)(wallPos[1]*facteurY)+decalageX;		
		int vertDoorY = (int)((((doors[0][1]-doors[0][0])/2)+doors[0][0])*facteurX)+decalageY;
		
		System.out.println("doors[0][1]-doors[0][0])/2+doors[0][0] := "+(((doors[0][1]-doors[0][0])/2)+doors[0][0]));
		System.out.println("wallPos[1] := "+wallPos[1]);
		System.out.println("vertDoorX := "+vertDoorX);
		System.out.println("vertDoorY := "+vertDoorY);
		
		return (new Point(vertDoorX,vertDoorY));
	}
	
	public Point getRedGoal(){
		return (new Point(redGoal[0],redGoal[1]));
	}
	
	public Point getGreenGoal(){
		return (new Point(greenGoal[0],greenGoal[1]));
	}
	
	public Point getBlueGoal(){
		return (new Point(blueGoal[0],blueGoal[1]));
	}
	
	
	public double getRobotAngle(){
		int[] robotCenter = getRobotCenter();
		double rapport;
		double angle = 0;
		double xTop = (double)avantRobot[0];
		double yTop = (double)avantRobot[1];
		double xMiddle = (double)robotCenter[0];
		double yMiddle = (double)robotCenter[1];
		if ((xTop<xMiddle) && (yTop<yMiddle)){
			rapport = (yMiddle-yTop)/(xMiddle-xTop);
			angle = 180 - Math.toDegrees(Math.atan(rapport));
		}
		if ((xTop>xMiddle) && (yTop<yMiddle)){
			rapport = (yMiddle-yTop)/(xTop-xMiddle);
			angle = Math.toDegrees(Math.atan(rapport));
		}
		if ((xTop<xMiddle) && (yTop>yMiddle)){
			rapport = (yTop-yMiddle)/(xMiddle-xTop);
			angle = 180+Math.toDegrees(Math.atan(rapport));
		}
		if ((xTop>xMiddle) && (yTop>yMiddle)){
			rapport = (yTop-yMiddle)/(xTop-xMiddle);
			angle = 360-Math.toDegrees(Math.atan(rapport));
		}
		if ((xTop==xMiddle) && (yTop<yMiddle)){
			angle = 90;
		}
		if ((xTop==xMiddle) && (yTop>yMiddle)){
			angle = 270;
		}
		if ((xTop<xMiddle) && (yTop==yMiddle)){
			angle = 180;
		}
		if ((xTop>xMiddle) && (yTop==yMiddle)){
			angle = 0;
		}
		return angle+180;
	}
	
	
	public int[] getRobotCenter(){
		int[] center = new int[2];
		int centerX = 0;
		int centerY = 0;
		for (int i=0; i<coinRobot.length; i++){
			centerX = centerX+coinRobot[i][0];
			centerY = centerY+coinRobot[i][1];
		}
		centerX = centerX/4;
		centerY = centerY/4;
		center[0] = centerX;
		center[1] = centerY;
		
		return center;
	}
	
	
	
	
}