/* EHRLER FREDERIC - MICHEL DERIAZ
 * ------------------------------------------------------------------
 * classe principale qui fait la liaison entre le simulateur du robot
 * et la partie analyse d'image. On aimerais au final retourner un 
 * objet de type position qui permet de situer tout les elements sur
 * le terrain.
 *
 */

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.*;
import java.awt.image.*;

public class TerrainDistributor{
	ImageAnalyserJAI imageAnalyserJAI;
	ImageDistributor imageDistributor;
	ControlDisplayer controlDisplayer;
	
	public TerrainDistributor(){
		imageDistributor = new ImageDistributor();
		imageAnalyserJAI = new ImageAnalyserJAI();
		controlDisplayer = new ControlDisplayer();
	}
	
	public Positions getPositions(){
		System.out.println("demande d'un terrain au terrain distibutor");
		Image img = imageDistributor.getImage();
		ParamDistributor param = controlDisplayer.getParam(); 
		imageAnalyserJAI.changeImage(img);
		imageAnalyserJAI.applyEffect(param);
		Terrain terrain = imageAnalyserJAI.getNewTerrain(img);
		Vector imageList = imageAnalyserJAI.getFinalImage();
		
		controlDisplayer.setRefImage(img);
		controlDisplayer.setNewImage(imageList);

		Positions positions = new Positions();
		positions.horizontalDoor = terrain.getHorizontalDoor();
		positions.verticalDoor = terrain.getVerticalDoor();
		positions.blueCylinder = terrain.getBlueCylPos();
		positions.redCylinder = terrain.getRedCylPos();
		positions.greenCylinder = terrain.getGreenCylPos();
		positions.blueGoal = terrain.getBlueGoal();
		positions.greenGoal = terrain.getGreenGoal();
		positions.redGoal = terrain.getRedGoal();
		positions.rcx = terrain.getRcx();
		
		verifyPosition(positions);
		return positions;
	}
	
	public void verifyPosition(Positions positions){
		System.out.println("verification des positions ----------------------------");
		System.out.println("horizontal door :="+positions.horizontalDoor.x+";"+positions.horizontalDoor.y);
		System.out.println("vertical door :="+positions.verticalDoor.x+";"+positions.verticalDoor.y);
		System.out.println("blue Cylinder :="+positions.blueCylinder.x+";"+positions.blueCylinder.y);
		System.out.println("red Cylinder :="+positions.redCylinder.x+";"+positions.redCylinder.y);
		System.out.println("green Cylinder :="+positions.greenCylinder.x+";"+positions.greenCylinder.y);
		System.out.println("blue Goal :="+positions.blueGoal.x+";"+positions.blueGoal.y);
		System.out.println("green Goal :="+positions.greenGoal.x+";"+positions.greenGoal.y);
		System.out.println("red Goal :="+positions.redGoal.x+";"+positions.redGoal.y);
		System.out.println("rcx :="+positions.rcx.x+";"+positions.rcx.y+";"+positions.rcx.a);
	}		
}
	