// Updates: 2002.06.24


import josx.robotics.*;
import josx.rcxcomm.*; 
import josx.platform.rcx.*;
import josx.util.*;
import java.io.*;


public class ContestRCX  {
  short powerA = 7;
  short powerC = 6;
  float timeOneMeter = 7.8717f;
  float timeRotate = 2.5543f;
  short delay = 12;
  
  short powerA2 = 6;
  short powerC2 = 7;
  float timeOneMeter2 = 8.13f;
  float timeRotate2 = 3.1986f;
  short delay2 = 12;  
  
  DataOutputStream out;   
  DataInputStream in;
  TimingNavigator nav;
  
  
  public ContestRCX() {
    RCXPort port = null;
    try {
      port = new RCXPort(); 
    }
    catch (IOException e) {}
    out = new DataOutputStream(port.getOutputStream());
    in = new DataInputStream(port.getInputStream());          
    Motor.A.setPower(powerA);
    Motor.C.setPower(powerC);    
    nav = new TimingNavigator(Motor.C, Motor.A, timeOneMeter, timeRotate);    
    nav.setMomentumDelay(delay);     
    while (true) {
      try {
        short angle = in.readShort();
        short dist = in.readShort();
        if (angle > 500) special(angle);
        else {
          nav.rotate((float)angle);
          nav.travel(dist/10);
          out.writeShort(1);
        }
      }
      catch (IOException e) {}
    }
  }    

    
  public static void main(String[] args) {
    Serial.setRangeLong();
    new ContestRCX();
  }

 
  private void special(short cmd) {
    if ((cmd == GC.CMD_OPEN) ||
       (cmd == GC.CMD_CLOSE) ||
       (cmd == GC.CMD_RELAX) ||
       (cmd == GC.CMD_TAKE_CYL) ||
       (cmd == GC.CMD_DROP_CYL)) pliers(cmd);
    if ((cmd == GC.LEFT_10x36) || 
       (cmd == GC.RIGHT_10x36)) turnTest(cmd);
    try {
      out.writeShort(1);    
    }
    catch (IOException e) {}       
  }
  

  private void pliers(short cmd) {
    if (cmd == GC.CMD_OPEN) Motor.B.forward();
    else if (cmd == GC.CMD_CLOSE) Motor.B.backward();
    else if (cmd == GC.CMD_RELAX) Motor.B.stop();
    else if (cmd == GC.CMD_TAKE_CYL) {
      Motor.B.forward();
      nav.travel(10);
      Motor.B.backward();
      wait(100);
      Motor.B.stop();

      Motor.A.setPower(powerA2);
      Motor.C.setPower(powerC2);    
      nav = new TimingNavigator(Motor.C, Motor.A, timeOneMeter2, timeRotate2);    
      nav.setMomentumDelay(delay2);   
    }
    else if (cmd == GC.CMD_DROP_CYL) {
      Motor.A.setPower(powerA);
      Motor.C.setPower(powerC);    
      nav = new TimingNavigator(Motor.C, Motor.A, timeOneMeter, timeRotate);    
      nav.setMomentumDelay(delay);     
      
      Motor.B.forward();
      wait(100);
      nav.travel(-10);
      Motor.B.backward();
      wait(10);
      Motor.B.stop();
    }    
  }

  
  private void turnTest(short cmd) {
    if (cmd == GC.LEFT_10x36) {
      for (int i = 0; i < 36; i++) {
        nav.rotate(10);
        wait(100);
      }
    }    
    else {
      for (int i = 0; i < 36; i++) {
        nav.rotate(-10);
        wait(100);
      }
    }         
  }
  

  private void wait(int t) {
    try {
      Thread.sleep(t);
    } catch (InterruptedException e) {}       
  }
}