// Updates: 2002.06.10


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;


public class Cylinder {
  static final int NULL = 0;
  static final int PLACED = 1;
  static final int PLACING = 2;
  
  static final int DIAMETER = 56;
  int state;
  int x, y;
  int index;
  
  
  public Cylinder(int index) {
    this.index = index;
  }
  
  
  public void paint(Graphics g) {
    draw(g, x, y);
  }
  
  
  public void paint(Graphics g, int tmpX, int tmpY) {
    draw(g, tmpX, tmpY);
  }    
  
  
  public void setState(int state) {
    this.state = state;
  }
  
  
  public int getState() {
    return state;
  }
  
  
  public boolean isPlaced() {
    if (state == PLACED) return true;
    else return false;
  }
  
  
  public boolean isPlacing() {
    if (state == PLACING) return true;
    else return false;
  }
    
  
  public Point getPosition() {
    return new Point(x, y);
  }
  
  
  public void setPosition(Point p) {
    setPosition(p.x, p.y);
  }
  
    
  public void setPosition(int x, int y) {
    this.x = x;
    this.y = y;
    state = PLACED;
  }


  private void draw(Graphics g, int x, int y) {
    if (index == 0) g.setColor(Color.blue);
    if (index == 1) g.setColor(Color.green);
    if (index == 2) g.setColor(Color.red);
    g.fillOval(x-DIAMETER/2, y-DIAMETER/2, DIAMETER, DIAMETER);
  }
}