// Updates: 2002.06.10


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;


public class Door {
  static final int NULL = 0;
  static final int PLACED = 1;
  static final int PLACING = 2;
  static final int HORIZONTAL = 10;
  static final int VERTICAL = 20;
  
  
  static final int WIDTH = 250;
  static final int FAR = 10000;
  int state;
  int x, y;
  int way;
  Door horizontalDoor;

  
  public Door() {
    way = HORIZONTAL;
  }
  
  
  public Door(Door horizontalDoor) {
    way = VERTICAL;
    this.horizontalDoor = horizontalDoor;
  }  
  
  
  public void paint(Graphics g) {
    draw(g, x, y);
  }
  
  
  public void paint(Graphics g, int tmpX, int tmpY) {
    draw(g, tmpX, tmpY);
  }    
  
  
  public void setState(int state) {
    this.state = state;
  }
  
  
  public int getState() {
    return state;
  }
  
  
  public boolean isPlaced() {
    if (state == PLACED) return true;
    else return false;
  }
  
  
  public boolean isPlacing() {
    if (state == PLACING) return true;
    else return false;
  }
    
  
  public Point getPosition() {
    return new Point(x, y);
  }
  
  
  public int getX() {
    return x;
  }
  
  
  public int getY() {
    return y;
  }
  

  public void setPosition(Point p) {
    setPosition(p.x, p.y);
  }
  
          
  public void setPosition(int x, int y) {
    this.x = x;
    this.y = y;
    state = PLACED;
  }


  private void draw(Graphics g, int x, int y) {
    g.setColor(Color.black);
    if (way == HORIZONTAL) {
      g.fillRect(0, y-6, x-WIDTH/2, 9);
      g.fillRect(x+WIDTH/2, y-6, FAR, 9);
    }
    else {
      g.fillRect(x-6, horizontalDoor.getY(), 9, y-WIDTH/2-horizontalDoor.getY());
      g.fillRect(x-6, y+WIDTH/2, 9, FAR);
    }
  }
}