// Updates: 2002.06.10


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;


public class RCX {
  static final int NULL = 0;
  static final int PLACED = 1;
  static final int PLACING = 2;
  
  int state;
  int x, y, a;
  Color cylinderColor = Color.black;
  
  
  public RCX() {
  }
  
  
  public void paint(Graphics g) {
    draw(g, x, y, a);
  }
  
  
  public void paint(Graphics g, int tmpX, int tmpY) {
    draw(g, tmpX, tmpY, 0);
  }    
  
  
  public void setState(int state) {
    this.state = state;
  }
  
  
  public int getState() {
    return state;
  }
  

  public boolean isPlaced() {
    if (state == PLACED) return true;
    else return false;
  }
  
  
  public boolean isPlacing() {
    if (state == PLACING) return true;
    else return false;
  }  
  
  public Triplet getPosition() {
    return new Triplet(x, y, a);
  }
  
    
  public void setPosition(int x, int y, int a) {
    this.x = x;
    this.y = y;
    this.a = a;
    state = PLACED;
  }


  public void setPosition(Triplet t) {
    setPosition(t.x, t.y, t.a);
  }
  
    
  public void takeCylinder() {
    travel(100);
  }
  
  
  public void dropCylinder() {
    travel(-100);
  }
  
  
  public void rotate(int angle) {
    a = (a + angle) % 360; 
  }
  
  
  public void travel(int dist) {
    x -= dist * Math.sin(Math.toRadians(a));
    y += dist * Math.cos(Math.toRadians(a));
  }
  
  
  public void carry(Color color) {
    cylinderColor = color;
  }
  
  
  private void draw(Graphics g, int x, int y, int a) {
    Graphics2D g2 = (Graphics2D)g;
    g2.setColor(Color.yellow);
    g2.setStroke(new BasicStroke(64.0f));
    int deltaX = (int)(24*Math.sin(Math.toRadians(a)));
    int deltaY = (int)(24*Math.cos(Math.toRadians(a)));
    g2.drawLine(x-deltaX,y+deltaY,x+deltaX,y-deltaY);
    g2.setColor(cylinderColor);
    g2.fillOval(x-deltaX-14,y+deltaY-14,28,28);
  }
}