// Updates: 2002.06.21


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;
import java.io.*;
import josx.rcxcomm.*;


public class Tower {
  DataOutputStream out; 
  DataInputStream in;  
  RCXPort port;
  
  public Tower() {
    try {
      port = new RCXPort("usb");
      out = new DataOutputStream(port.getOutputStream());      
      in = new DataInputStream(port.getInputStream()); 
    }
    catch (IOException e) {
      e.printStackTrace();  
      System.exit(0);
    }      
  }


  public void execute(String cmd) {
    String sAngle = cmd.substring(0, cmd.indexOf(" "));
    String sDist = cmd.substring(cmd.indexOf(" ") + 1, cmd.length());
    short angle = Short.parseShort(sAngle);
    short dist = Short.parseShort(sDist);
    send(angle);
    send(dist);
    receive();
  }  


  public void close() {
    try {
      port.close();
      out.close();
      in.close();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }
      
  
  private void send(short msg) {
    try {
      out.writeShort(msg);
      out.flush();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }


  private short receive() {
    short msg = 0;
    try {
      msg = in.readShort();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    return msg;
  }    
}