// Updates: 2002.05.27


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;
import java.io.*;
import josx.rcxcomm.*;


public class GoPC extends JFrame implements ActionListener {
  DataOutputStream out; 
  DataInputStream in;  
  JTextFieldX tf;
  Signal signal;
  
  
  public GoPC() {
    super("Go !");
    
    JPanel p = new JPanel();
    p.setLayout(new BorderLayout());
    signal = new Signal();
    signal.setGreen();
    p.add(signal, BorderLayout.CENTER);
    tf = new JTextFieldX();
    tf.addActionListener(this);
    p.add(tf, BorderLayout.SOUTH);
    getContentPane().add(p);

    try {
      RCXPort port = new RCXPort("usb");
      out = new DataOutputStream(port.getOutputStream());      
      in = new DataInputStream(port.getInputStream()); 
    }
    catch (IOException e) {
      e.printStackTrace();  
      System.exit(0);
    }      

    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        System.exit(0);
      }
    });
    setSize(150, 150);
    Dimension d1 = getToolkit().getScreenSize();
    Dimension d2 = this.getSize();     
    setLocation(d1.width/2 - d2.width/2, d1.height/2 - d2.height/2);
    show();
  }


  public void actionPerformed(ActionEvent e) {
    signal.setRed();
    signal.paintComponent(signal.getGraphics());
      // obligatoire, car sinon le repaint du signal s'excutera qu'aprs
      // le retour de actionPerformed
    String input = tf.getText();
    String sAngle = input.substring(0, input.indexOf(" "));
    String sDist = input.substring(input.indexOf(" ") + 1, input.length());
    short angle = Short.parseShort(sAngle);
    short dist = Short.parseShort(sDist);
    send(angle);
    send(dist);
    receive();
    signal.setGreen();
  }  


  private void send(short msg) {
    try {
      out.writeShort(msg);
      out.flush();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }


  private short receive() {
    short msg = 0;
    try {
      msg = in.readShort();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    return msg;
  }    
    
    
  public static void main(String[] args) {
    new GoPC();
  }
}