// Updates: 2002.05.28


import josx.robotics.*;
import josx.rcxcomm.*; 
import josx.platform.rcx.*;
import josx.util.*;
import java.io.*;


public class GoRCX implements SensorListener {
  final int STOP = 0;
  final int OPEN = 1;
  final int CLOSE = 2;
  final int GET = 3;
  final int DROP = 4;
  short powerA = 7;
  short powerC = 6;
  float timeOneMeter = 8.0f;
  float timeRotate = 2.638f;
  short delay = 12;
  DataOutputStream out;   
  DataInputStream in;
  TimingNavigator nav;
  

  public GoRCX() {
//    Sensor.S2.addSensorListener(this);
    RCXPort port = null;
    try {
      port = new RCXPort(); 
    }
    catch (IOException e) {}
    out = new DataOutputStream(port.getOutputStream());
    in = new DataInputStream(port.getInputStream());          
    Motor.A.setPower(powerA);
    Motor.C.setPower(powerC);    
    nav = new TimingNavigator(Motor.C, Motor.A, timeOneMeter, timeRotate);    
    nav.setMomentumDelay(delay);     
    while (true) {
      try {
        short angle = in.readShort();
        short dist = in.readShort();
        if (angle == 500) pliers(STOP);
        else if (angle == 501) pliers(OPEN);
        else if (angle == 502) pliers(CLOSE);
        else if (angle == 503) pliers(GET);
        else if (angle == 504) pliers(DROP);
        else {
          nav.rotate((float)angle);
          nav.travel(dist);
        }
        out.writeShort(1);
      }
      catch (IOException e) {}
    }
  }    

    
  public static void main(String[] args) {
    Serial.setRangeLong();
    new GoRCX();
  }


  private void pliers(int operation) {
    if (operation == STOP) Motor.B.stop();
    else if (operation == OPEN) Motor.B.forward();
    else if (operation == CLOSE) Motor.B.backward();
    else if (operation == GET) {
      Motor.B.forward();
      nav.travel(10);
      Motor.B.backward();
      wait(100);
      Motor.B.stop();
    }
    else if (operation == DROP) {
      Motor.B.forward();
      wait(100);
      nav.travel(-10);
      Motor.B.backward();
      wait(10);
      Motor.B.stop();
    }    
  }
  
  
  private void wait(int t) {
    try {
      Thread.sleep(t);
    } catch (InterruptedException e) {}       
  }
  
  
  public void stateChanged(Sensor aSource, int aOldValue, int aNewValue) {
    if (Sensor.S2.readBooleanValue()) {
      Motor.A.stop();
      Motor.C.stop();      
      nav.stop();
    }
  }
}    