// Updates: 2002.01.16


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import java.util.*;



public class Signal extends JPanel {
  int minColor = 50;
  int red, green;
  
  
  public Signal() {
    Properties props = new Properties();
    try {
      props.load(new FileInputStream("Signal.properties"));
    }
    catch (IOException e) {
      System.out.println("Error: " + e);
    }
    minColor = Integer.parseInt(props.getProperty("minColor"));
    setBorder(BorderFactory.createTitledBorder("  State  "));
    red = 255;
    green = minColor; 
  }
  
  
  public void paintComponent(Graphics g) {
    super.paintComponent(g);
    g.setColor(Color.black);
    g.fillRoundRect(15, 20, 30, 55, 25, 25);
    g.setColor(new Color(red, 0, 0));
    g.fillOval(20, 25, 20, 20);
    g.setColor(Color.blue);
    g.drawString("Busy", 60, 40);
    g.setColor(new Color(0, green, 0));
    g.fillOval(20, 50, 20, 20);    
    g.setColor(Color.blue);
    g.drawString("Available", 60, 65);    
  }

  
  public void setRed() {
    red = 255;
    green = minColor;
    repaint();
  }
  
  
  public void setGreen() {
    red = minColor;
    green = 255;
    repaint();
  }
  
  
  public boolean isRed() {
    return (red == 255);
  }
  
  
  public boolean isGreen() {
    return (green == 255);
  }  
}