// Updates: 2002.05.18


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.io.*;
import josx.rcxcomm.*;


public class TeleRobot extends JFrame implements ActionListener {
  JButton avancer, tournerGauche, stopper, tournerDroite, reculer;
  RCXPort port;
  DataOutputStream out;
  
  
  public TeleRobot() {
    super("TeleRobot");
    JPanel p = new JPanel();
    p.setLayout(new GridLayout(3,3,10,10));
    p.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
    p.add(new JLabel());
    avancer = new JButton("Avancer");
    avancer.addActionListener(this);
    p.add(avancer);
    p.add(new JLabel());
    tournerGauche = new JButton("Gauche");
    tournerGauche.addActionListener(this);    
    p.add(tournerGauche);
    stopper = new JButton("Stop");
    stopper.addActionListener(this);      
    p.add(stopper);
    tournerDroite = new JButton("Droite");
    tournerDroite.addActionListener(this);      
    p.add(tournerDroite);
    p.add(new JLabel());
    reculer = new JButton("Reculer");
    reculer.addActionListener(this); 
    p.add(reculer);
    p.add(new JLabel());
    getContentPane().add(p);
    
    try {
      port = new RCXPort("usb");
    }
    catch (IOException e) {
      e.printStackTrace();  
      System.exit(0);
    }      
    out = new DataOutputStream(port.getOutputStream());

    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        System.exit(0);
      }
    });
    setSize(300, 200);
    Dimension d1 = getToolkit().getScreenSize();
    Dimension d2 = this.getSize();     
    setLocation(d1.width/2 - d2.width/2, d1.height/2 - d2.height/2);
    show();
  }


  public static void main(String[] args) {
    new TeleRobot();
  }


  public void actionPerformed(ActionEvent e) {
    JButton choix = (JButton)e.getSource();
    if (choix.equals(avancer)) send((short)1);
    if (choix.equals(tournerGauche)) send((short)2);
    if (choix.equals(stopper)) send((short)3);
    if (choix.equals(tournerDroite)) send((short)4);
    if (choix.equals(reculer)) send((short)5);
  }  
  
  
  private void send(short msg) {
    try {
      out.writeShort(msg);
      out.flush();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }
}